// Global vars
var ClientsDataStore;
var ClientsTypesDataStore;
var CitiesDataStore;
var ClientsColumnModel;
var ClientsTypesColumnModel;
var CitiesColumnModel;
var ClientListingEditorGrid;
var ClientListingWindow;
var ClientCreateForm;
var ClientCreateWindow;
var FirstNameField;
var LastNameField;
var EnteringOfficeField;
var LeavingOfficeField;
var IncomeField;
var PartyField;
var ClientListingSelectedRow;
var ClientListingContextMenu;

Ext.onReady(function(){

  Ext.QuickTips.init();
  
  // This saves the Client after a cell has been edited
  function saveTheClient(oGrid_event){
   Ext.MessageBox.wait('Updating!', 'Please Wait ...');
   Ext.Ajax.request({   
      waitMsg: 'Please wait...',
      url: 'database.php',
      params: {
         task: "UPDATECLIENT",
         id: oGrid_event.record.data.IDClient,
         name: oGrid_event.record.data.Name,
         address: oGrid_event.record.data.Address,
         type: oGrid_event.record.data.ClientType,
         city: oGrid_event.record.data.CityId,
         contactperson: oGrid_event.record.data.ContactPerson,
         sales: oGrid_event.record.data.Sales,
		 telephone: oGrid_event.record.data.Telephone,
		 fax: oGrid_event.record.data.Fax,
		 mobile: oGrid_event.record.data.Mobile,
		 website: oGrid_event.record.data.WebSite,
		 email: oGrid_event.record.data.Email
      }, 
      success: function(response){              
         var result=eval(response.responseText);
         switch(result){
         case 1:
            Ext.MessageBox.hide();
			ClientsDataStore.commitChanges();
            ClientsDataStore.reload();
            break;          
         default:
            Ext.MessageBox.hide();
			Ext.MessageBox.alert(response.responseText);
            break;
         }
      },
      failure: function(response){
         Ext.MessageBox.hide();
		 var result=response.responseText;
         Ext.MessageBox.alert('error','could not connect to the database. retry later');    
      }                      
   });   
  }

  function saveMaterial(oGrid_event){
   Ext.MessageBox.wait('Updating!', 'Please Wait ...');
   Ext.Ajax.request({   
      waitMsg: 'Please wait...',
      url: 'database.php',
      params: {
         task: "UPDATEMAT",
         id: oGrid_event.record.data.Id,
         materialid: oGrid_event.record.data.ProductId,
         supplierid: oGrid_event.record.data.SupplierId,
         qty: oGrid_event.record.data.Qty
      }, 
      success: function(response){              
         Ext.MessageBox.hide();
		 var result=eval(response.responseText);
         switch(result){
         case 0:
		 case 1:
			MaterialsDataStore.commitChanges();
            var selections = ClientListingEditorGrid.selModel.getSelections();
			MaterialsDataStore.reload({params: {id:selections[0].json.Id}});
            break;          
         default:
			Ext.MessageBox.alert(response.responseText);
            break;
         }
      },
      failure: function(response){
         Ext.MessageBox.hide();
		 var result=response.responseText;
         Ext.MessageBox.alert('error','could not connect to the database. retry later');    
      }                      
   });   
  }


 // this creates a new Client
  function createTheClient(){
     if(isClientFormValid2()){
      Ext.MessageBox.wait('Updating!', 'Please Wait ...');
	  Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "CREATECLIENT",
          name:      			NameField2.getValue(),
          address:       		 AddressField2.getValue(),
          type: 				ClientsTypesField2.getValue(),
          sales:  			   SalesField2.getValue(),
          website:          	 WebSiteField2.getValue(),
          email:          	   EmailField2.getValue(),
		  notes:          	   NotesField2.getValue(),
		  contactperson:	   ContactPersonField2.getValue(),
		  city:          	    CitiesField2.getValue(),
		  telephone:           TelephoneField2.getValue(),
		  mobile:          	  MobileField2.getValue(),
		  fax:	          	 FaxField2.getValue()
        }, 
        success: function(response){              
          Ext.MessageBox.hide();
		  var result=eval(response.responseText);
          switch(result){
          case 1:
			Ext.MessageBox.alert('Creation OK','The Client was created successfully.');
            ClientsDataStore.reload();
            ClientCreateWindow.hide();
            break;
          default:
			Ext.MessageBox.alert('Could not add the client');
            break;
          }        
        },
        failure: function(response){
          Ext.MessageBox.hide();
          var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
    } else {
	  Ext.MessageBox.alert('Warning', 'Your Form is not valid!');
    }
  }
  
  function updateTheClient(){
     if(isClientFormValid()){
      Ext.MessageBox.wait('Updating!', 'Please Wait ...');
	  Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "UPDATECLIENT",
          id: 				  ClientIdField.getValue(),
		  name:      			NameField.getValue(),
          address:       		 AddressField.getValue(),
          type: 				ClientsTypesField.getValue(),
          sales:  			   SalesField.getValue(),
          website:          	 WebSiteField.getValue(),
          email:          	   EmailField.getValue(),
		  notes:          	   NotesField.getValue(),
		  contactperson:	   ContactPersonField.getValue(),
		  city:          	    CitiesField.getValue(),
		  telephone:           TelephoneField.getValue(),
		  mobile:          	  MobileField.getValue(),
		  fax:	          	 FaxField.getValue()
        }, 
        success: function(response){              
          var result=eval(response.responseText);
          Ext.MessageBox.hide();
		  switch(result){
          case 1:
		  case 0:
			Ext.MessageBox.alert('Update OK','The Client was updated successfully.');
            ClientsDataStore.reload();
			ClientEditWindow.hide();
            break;
          default:
			Ext.MessageBox.alert('Could not update the client');
            break;
          }        
        },
        failure: function(response){
          Ext.MessageBox.hide();
		  var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
    } else {
	  Ext.MessageBox.alert('Warning', 'Your Form is not valid!');
	  //console.log(response.responseText);
    }
  }
  
  function addMaterial(){
	var selections = ClientListingEditorGrid.selModel.getSelections();
	Ext.MessageBox.wait('Updating!', 'Please Wait ...');
	Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "ADDMAT",
          id: 				  selections[0].json.Id,
		  materialid:      	  MaterialField.getValue(),
          supplierid:       	  SupplierField.getValue(),
          qty: 				 QtyField.getValue()
        }, 
        success: function(response){              
          Ext.MessageBox.hide();
		  var result=eval(response.responseText);
          //console.log(result);
		  switch(result){
          case 1:
		  case 0:
			Ext.MessageBox.alert('Update OK','The Client was updated successfully.');
			MaterialsDataStore.load({params: {id:selections[0].json.Id}});
			AddMaterialWindow.hide();
            break;
          default:
            Ext.MessageBox.alert('Could not update the client');
            break;
          }        
        },
        failure: function(response){
		  Ext.MessageBox.hide();
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
  }
  
  
  // reset the Form before opening it
  function resetClientForm(){
    NameField.setValue('');
    AddressField.setValue('');
    NotesField.setValue('');
    EmailField.setValue('');
    SalesField.setValue('');
    WebSiteField.setValue('');    
  }
  function fillClientForm(rec){
	ClientIdField.setValue(rec.get('IDClient'));
    NameField.setValue(rec.get('Name'));
	ContactPersonField.setValue(rec.get('ContactPerson'));
    AddressField.setValue(rec.get('Address'));
    NotesField.setValue(rec.get('Notes'));
    EmailField.setValue(rec.get('Email'));
    SalesField.setValue(rec.get('Sales'));
    WebSiteField.setValue(rec.get('WebSite'));
	CitiesField.setValue(rec.get('CityId'));
	ClientsTypesField.setValue(rec.get('ClientType'));
	MobileField.setValue(rec.get('Mobile'));
	TelephoneField.setValue(rec.get('Telephone'));
	FaxField.setValue(rec.get('Fax'));
  }
  
  // check if the form is valid
  function isClientFormValid(){
      return(NameField.isValid() && AddressField.isValid() && ClientsTypesField.isValid() && WebSiteField.isValid() && SalesField.isValid() && CitiesField.isValid() && EmailField.isValid());
  }

  function isClientFormValid2(){
      return(true);
  }


  // display or bring forth the form
  function displayFormWindow(){
     if(!ClientCreateWindow.isVisible()){
       resetClientForm();
       ClientCreateWindow.show();
	   //ClientCreateWindow.toFront();
     } else {
       ClientCreateWindow.toFront();
     }
  }

  function displayMaterialWindow(){
     if(!AddMaterialWindow.isVisible()){
       //resetClientForm();
       AddMaterialWindow.show();
	   //ClientCreateWindow.toFront();
     } else {
       AddMaterialWindow.toFront();
     }
  }

  function closeMaterials(){
	 MaterialsWindow.hide();		
  }
  function displayMaterialsWindow(rec){
	if(ClientListingEditorGrid.selModel.getCount() > 0) {
		ProductsDataStore.load();
		SuppliersDataStore.load();
		var selections = ClientListingEditorGrid.selModel.getSelections();
		MaterialsDataStore.load({params: {id:selections[0].json.Id}});
		if(!MaterialsWindow.isVisible()){
       		resetClientForm();
       		MaterialsWindow.show();
	    } else {
       		MaterialsWindow.toFront();
     	}
	} else {
		Ext.MessageBox.alert('Error','Please select a client');
	}
		
	
  }


  function editFormWindow(rec){
     if(!ClientEditWindow.isVisible()){
       fillClientForm(rec);
       ClientEditWindow.show();
     } else {
       ClientEditWindow.toFront();
     }
  }
  
  // This was added in Tutorial 6
  function confirmDeleteClients(){
    if(ClientListingEditorGrid.selModel.getCount() == 1) // only one Client is selected here
    {
      Ext.MessageBox.confirm('Confirmation','You are about to delete a Client. Continue?', deleteClients);
    } else if(ClientListingEditorGrid.selModel.getCount() > 1){
      Ext.MessageBox.confirm('Confirmation','Delete those Clients?', deleteClients);
    } else {
      Ext.MessageBox.alert('Error','Please select Client(s) to delete');
    }
  }  
   // This was added in Tutorial 6
  function deleteClients(btn){
    if(btn=='yes'){
         var selections = ClientListingEditorGrid.selModel.getSelections();
         //console.info('first:'+selections[0].data['IDClient']);
		 var prez = [];
         for(i = 0; i< ClientListingEditorGrid.selModel.getCount(); i++){
          prez.push(selections[i].data['IDClient']);
		  
		  //console.info(selections[0].data['IDClient']);
         }
         var encoded_array = Ext.encode(prez);
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url: 'database.php', 
            params: { 
               task: "DELETECLIENT", 
               ids:  encoded_array
              }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1:  // Success : simply reload
                ClientsDataStore.reload();
                break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }
  
  function confirmDeleteMaterial(){
    if(MaterialsGrid.selModel.getCount() == 1) // only one Client is selected here
    {
      Ext.MessageBox.confirm('Confirmation','You are about to delete a Client. Continue?', deleteMaterials);
    } else if(MaterialsGrid.selModel.getCount() > 1){
      Ext.MessageBox.confirm('Confirmation','Delete those Clients?', deleteMaterials);
    } else {
      Ext.MessageBox.alert('Error','Please select Client(s) to delete');
    }
  }  
   // This was added in Tutorial 6
  function deleteMaterials(btn){
    if(btn=='yes'){
         var selections = MaterialsGrid.selModel.getSelections();
         var prez = [];
         for(i = 0; i< MaterialsGrid.selModel.getCount(); i++){
          prez.push(selections[i].json.Id);
         }
         var encoded_array = Ext.encode(prez);
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url: 'database.php', 
            params: { 
               task: "DELETEMATERIAL", 
               ids:  encoded_array
              }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1:  // Success : simply reload
                var selectclient = ClientListingEditorGrid.selModel.getSelections();
				MaterialsDataStore.load({params: {id:selectclient[0].json.Id}});
				break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }
 
  function startAdvancedSearch(){
      // local vars
      var ClientSearchForm;
      var ClientSearchWindow;
      var SearchFirstNameItem;
      var SearchLastNameItem;
      var SearchPartyItem;
      var SearchEnteringItem;
      var SearchLeavingItem;
      
     function listSearch(){
         // render according to a SQL date format.
         var startDate = "";
         var endDate = "";
         if(SearchEnteringItem.getValue() !== "") {
            startDate = SearchEnteringItem.getValue().format('Y-m-d');
         }
         if(SearchLeavingItem.getValue() !== "") {
            endDate = SearchLeavingItem.getValue().format('Y-m-d');
         }
         
         // change the store parameters
        ClientsDataStore.baseParams = {
         task: 'SEARCH',
         firstname: SearchFirstNameItem.getValue(),
            lastname : SearchLastNameItem.getValue(),
            party : SearchPartyItem.getValue(),
            enteringoffice : startDate,
            leavingoffice : endDate
       };
         // Cause the datastore to do another query : 
       ClientsDataStore.reload({params: {start: 0, limit: 15}});
     }
     
     function resetSearch(){
         // reset the store parameters
        ClientsDataStore.baseParams = {
         task: 'LISTING'
       };
         // Cause the datastore to do another query : 
       ClientsDataStore.reload({params: {start: 0, limit: 15}});
         ClientSearchWindow.close();
     }
     
      SearchFirstNameItem = new Ext.form.TextField({
          fieldLabel: 'First Name',
          maxLength: 20,
          anchor : '95%',
          maskRe: /([a-zA-Z0-9\s]+)$/
            });

      SearchLastNameItem = new Ext.form.TextField({
          fieldLabel: 'Last Name',
          maxLength: 20,
          anchor : '95%',    
          maskRe: /([a-zA-Z0-9\s]+)$/  
            });
      
      SearchPartyItem = new Ext.form.ComboBox({
         fieldLabel: 'Party',
         store:new Ext.data.SimpleStore({
          fields:['partyValue', 'partyName'],
          data: [['1','No Party'],['2','Federalist'],['3','Democratic-Republican'],['4','Democratic'],['5','Whig'],['6','Republican']]
          }),
         mode: 'local',
         displayField: 'partyName',
         valueField: 'partyValue',
         anchor:'95%',
         triggerAction: 'all'
            });
            
      SearchEnteringItem = new Ext.form.DateField({
          fieldLabel: 'Entered Office after',
          format : 'm/d/Y',
          anchor:'95%'
          });
          
      SearchLeavingItem = new Ext.form.DateField({
          fieldLabel: 'Left Office before',
          format : 'm/d/Y',
          anchor:'95%'
          });
    
     ClientSearchForm = new Ext.FormPanel({
       //labelAlign: 'top',
       bodyStyle: 'padding: 5px',
       width: 300,
       items: [{
         layout: 'form',
         border: false,
         items: [ SearchFirstNameItem,SearchLastNameItem,SearchPartyItem,SearchEnteringItem, SearchLeavingItem ],
         buttons: [{
               text: 'Search',
               handler: listSearch
             },{
               text: 'Close',
               handler: resetSearch
             }]
         }]
     });
 
     
     ClientSearchWindow = new Ext.Window({
         title: 'Client Search',
         closable:true,
         width: 200,
         height: 400,
         plain:true,
         layout: 'fit',
         items: ClientSearchForm
     });
 
     
     // once all is done, show the search window
     ClientSearchWindow.show();
  } 
  
    function printListing(){
      var searchquery = "";
      var searchfirstname = "";
      var searchlastname = "";
      var searchparty = "";
      var searchenteringoffice = "";
      var searchleavingoffice = "";
      var win;               // our popup window
      // check if we do have some search data...
      if(ClientsDataStore.baseParams.query!==null){searchquery = ClientsDataStore.baseParams.query;}
      if(ClientsDataStore.baseParams.firstname!==null){searchfirstname = ClientsDataStore.baseParams.firstname;}
      if(ClientsDataStore.baseParams.lastname!==null){searchlastname = ClientsDataStore.baseParams.lastname;}
      if(ClientsDataStore.baseParams.party!==null){searchparty = ClientsDataStore.baseParams.party;}
      if(ClientsDataStore.baseParams.enteringoffice!==null){searchenteringoffice = ClientsDataStore.baseParams.enteringoffice;}
      if(ClientsDataStore.baseParams.leavingoffice!==null){searchleavingoffice = ClientsDataStore.baseParams.leavingoffice;}
         
      Ext.Ajax.request({   
        waitMsg: 'Please Wait...',
        url: 'database.php',
        params: {
          task: "PRINT",
               // we have to send all of the search

          query: searchquery,                                 // if we are doing a quicksearch, use this
          firstname : searchfirstname,                        // if we are doing advanced search, use this
          lastname : searchlastname,
          party : searchparty,
          enteringoffice : searchenteringoffice,
          leavingoffice : searchleavingoffice,
          currentlisting: ClientsDataStore.baseParams.task // this tells us if we are searching or not
        }, 
        success: function(response){              
          var result=eval(response.responseText);
          switch(result){
          case 1:
            win = window.open('./Clientslist.html','Clientslist','height=400,width=600,resizable=1,scrollbars=1, menubar=1');
            win.print();
            break;
          default:
            Ext.MessageBox.alert('Uh hu...','Unable to print the grid!');
            break;
          }  
        },
        failure: function(response){
          var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');      
        }                      
      });
  }
 
  function onClientListingEditorGridContextMenu(grid, rowIndex, e) {
    e.stopEvent();
    var coords = e.getXY();
    ClientListingContextMenu.rowRecord = grid.store.getAt(rowIndex);
    grid.selModel.selectRow(rowIndex);
    ClientListingSelectedRow=rowIndex;
    ClientListingContextMenu.showAt([coords[0], coords[1]]);
  }
 
  function modifyClientContextMenu(){
      ClientListingEditorGrid.startEditing(ClientListingSelectedRow,1);
  }

  function deleteClientContextMenu(){
      confirmDeleteClients();
  }

  function printListingContextMenu(){
      printListing();
  }

  
  // << CONFIG >>
  ClientsDataStore = new Ext.data.Store({
      id: 'ClientsDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTING"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'IDClient', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'},
        {name: 'Address', type: 'string', mapping: 'Address'},
        {name: 'ClientType', type: 'string', mapping: 'Type'},
        {name: 'CityId', type: 'string', mapping: 'City'},
        {name: 'ContactPerson', type: 'string', mapping: 'ContactPerson'},
        {name: 'Sales', type: 'float', mapping: 'Sales'},
		{name: 'Telephone', type: 'string', mapping: 'Telephone'},
        {name: 'Fax', type: 'string', mapping: 'Fax'},
		{name: 'Mobile', type: 'string', mapping: 'Mobile'},
		{name: 'WebSite', type: 'string', mapping: 'WebSite'},
		{name: 'Email', type: 'string', mapping: 'Email'},
		{name: 'Notes', type: 'string', mapping: 'Notes'}
      ]),
      sortInfo:{field: 'IDClient', direction: "ASC"}
    });

  MaterialsDataStore = new Ext.data.Store({
      id: 'MaterialsDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: 'MATERIALS',
						id: "1"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'Id', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'},
        {name: 'SupplierId', type: 'int', mapping: 'SupplierId'},
        {name: 'ProductId', type: 'int', mapping: 'ProductId'},
        {name: 'ClientId', type: 'string', mapping: 'ClientId'},
        {name: 'Qty', type: 'float', mapping: 'Qty'}
      ]),
      sortInfo:{field: 'Id', direction: "ASC"}
    });


  ClientsTypesDataStore = new Ext.data.Store({
      id: 'ClientsTypesDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "TYPES"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'id'
      },[ 
        {name: 'IDType', type: 'int', mapping: 'id'},
        {name: 'Name', type: 'string', mapping: 'name'}
      ]),
      sortInfo:{field: 'Name', direction: "ASC"}
    });
  
  CitiesDataStore = new Ext.data.Store({
      id: 'CitiesDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "CITIES"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'IDCity', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'}
      ]),
      sortInfo:{field: 'Name', direction: "ASC"}
    });

   ProductsDataStore = new Ext.data.Store({
      id: 'ProductsDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "PRODUCTS"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'Id', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'}
      ]),
      sortInfo:{field: 'Name', direction: "ASC"}
    });

   SuppliersDataStore = new Ext.data.Store({
      id: 'SuppliersDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTSUPP"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'Id', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'}
      ]),
      sortInfo:{field: 'Name', direction: "ASC"}
    });


  ClientsColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'IDClient',
        width: 40,        
        renderer: function(value, cell){ 
         //cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Name',
        dataIndex: 'Name',
        width: 60,
        editor: new Ext.form.TextField({
            allowBlank: false,
            maxLength: 20,
            maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Address',
        dataIndex: 'Address',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'City',
        dataIndex: 'CityId',
        width: 80,
        editor: new Ext.form.ComboBox({
          store:CitiesDataStore,
     	  mode: 'local',
     	  displayField: 'Name',
     	  allowBlank: false,
          valueField: 'IDCity',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(data,value, cell){ 
			//cell.css = "coolcell";
			record = CitiesDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.Name;
            } else {
                                    //return data;
                return 'Invalid city';
            }        }
      },{
        header: 'Client Type',
        dataIndex: 'ClientType',
        width: 80,
        editor: new Ext.form.ComboBox({
          store:ClientsTypesDataStore,
     	  mode: 'local',
     	  displayField: 'Name',
     	  allowBlank: false,
          valueField: 'IDType',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(data,value, cell){ 
			//cell.css = "coolcell";
			record = ClientsTypesDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.Name;
            } else {
                                    //return data;
                return data;
            }        
		}
      },{
        header: 'Contact Person',
        dataIndex: 'ContactPerson',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: "Sales",
        dataIndex: 'Sales',
        width: 100,
        renderer: function(value, cell){ 
         var str = '';
         //cell.css = "coolcell";
		 if(value > 1000000){
            str = "<span style='color:#336600;'>$ " + value + "</span>";
         } else if (value > 100000 && value < 1000000){
            str = "<span style='color:#FF9900;'>$ " + value + "</span>";
         } else {
            str = "<span style='color:#CC0000;'>$ " + value + "</span>";
         }
         return str; 
        },
        editor: new Ext.form.NumberField({
          allowBlank: false,
          allowDecimals: true,
          allowNegative: false,
          blankText: '0',
          maxLength: 11
          })
      },{
        header: 'Telephone',
        dataIndex: 'Telephone',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Fax',
        dataIndex: 'Fax',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Mobile',
        dataIndex: 'Mobile',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Website',
        dataIndex: 'WebSite',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Email',
        dataIndex: 'Email',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Notes',
        dataIndex: 'Notes',
		hidden: true,
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      }]
    );
    ClientsColumnModel.defaultSortable= true;
    
  ClientsTypesColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'IDType',
        width: 20,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Type',
        readOnly: true,
        dataIndex: 'Name',
        width: 40,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      }]
  );
  ClientsTypesColumnModel.defaultSortable= true;

  MaterialsColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'Id',
        width: 40,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Name',
        readOnly: false,
        dataIndex: 'ProductId',
        width: 100,        
        editor: new Ext.form.ComboBox({
          store:ProductsDataStore,
     	  mode: 'local',
     	  displayField: 'Name',
     	  allowBlank: false,
          valueField: 'Id',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),        
		  renderer: function(data,value, cell){ 
			//cell.css = "coolcell";
			record = ProductsDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.Name;
            } else {
                                    //return data;
                return data;
            }        
		},
        hidden: false
      },{
        header: 'Supplier',
        readOnly: false,
        dataIndex: 'SupplierId',
        width: 100,   
        editor: new Ext.form.ComboBox({
          store:SuppliersDataStore,
     	  mode: 'local',
     	  displayField: 'Name',
     	  allowBlank: false,
          valueField: 'Id',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),        
		
        renderer: function(data,value, cell){ 
			//cell.css = "coolcell";
			record = SuppliersDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.Name;
            } else {
                                    //return data;
                return data;
            }        
		},
        hidden: false
      },{
        header: 'Quantity',
        readOnly: false,
        dataIndex: 'Qty',
        width: 40,   
		        editor: new Ext.form.NumberField({
          allowBlank: false,
          allowDecimals: true,
          allowNegative: false,
          blankText: '0',
          maxLength: 11
          }),
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      }]
  );
  MaterialsColumnModel.defaultSortable= true;

  CitiesColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'IDCity',
        width: 20,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'City',
        readOnly: true,
        dataIndex: 'Name',
        width: 40,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      }]
  );
  CitiesColumnModel.defaultSortable= true;

  ClientListingEditorGrid =  new Ext.grid.EditorGridPanel({
      id: 'ClientListingEditorGrid',
      store: ClientsDataStore,
      cm: ClientsColumnModel,
      enableColLock:false,
      clicksToEdit:3,
      selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
      bbar: new Ext.PagingToolbar({
                pageSize: 15,
                store: ClientsDataStore,
                displayInfo: true
            }),
      tbar: [
          {
            text: 'Client\'s Materials',
            tooltip: 'Materials used by the client',
            iconCls:'add',                      // reference to our css
            handler: displayMaterialsWindow
          },'-',{
            text: 'Add a Client',
            tooltip: 'Add a new client',
            iconCls:'add',                      // reference to our css
            handler: displayFormWindow
          }, '-', { 
            text: 'Delete selection',
            tooltip: 'Jose, can you seeeee??',
            handler: confirmDeleteClients,   // Confirm before deleting
            iconCls:'remove'
          }, '-', { // Added in Tutorial 8
            text: 'Search',
            tooltip: 'Advanced Search',
            handler: startAdvancedSearch,   
            iconCls:'search'
          }, '-', new Ext.app.SearchField({
                    store: ClientsDataStore,
            params: {start: 0, limit: 15},
                    width: 120
        }),'-', {
            text: 'Print',
        tooltip: 'Print me!',
            handler: printListing, 
            iconCls:'print'
          }
      ]
    });
  ClientListingEditorGrid.addListener('rowcontextmenu', onClientListingEditorGridContextMenu);
  ClientListingEditorGrid.on('rowdblclick', function(grid, rowIndex) {
         var record = grid.store.getAt(rowIndex);
         if (record) {
                //console.info('You selected ' + record.get('AufgabenNr'));
				editFormWindow(record);
         }
        

    });
   
  ClientListingContextMenu = new Ext.menu.Menu({
      id: 'ClientListingEditorGridContextMenu',
      items: [
      { text: 'Modify this Client', handler: modifyClientContextMenu },
      { text: 'Delete this Client', handler: deleteClientContextMenu },
      '-',
      { text: 'Print this grid', handler: printListingContextMenu }
      ]
   });    
// Start of Materials Grid Difination
  MaterialsGrid =  new Ext.grid.EditorGridPanel({
      id: 'MaterialsGrid',
      store: MaterialsDataStore,
      cm: MaterialsColumnModel,
      enableColLock:false,
      clicksToEdit:2,
      selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
      bbar: new Ext.PagingToolbar({
                pageSize: 15,
                store: MaterialsDataStore,
                displayInfo: true
            }),
      tbar: [
          {
            text: 'Add a Material',
            tooltip: 'Add a new Material',
            iconCls:'add',                      // reference to our css
            handler: displayMaterialWindow
          }, '-', { 
            text: 'Delete selection',
            tooltip: 'Jose, can you seeeee??',
            handler: confirmDeleteMaterial,   // Confirm before deleting
            iconCls:'remove'
          }, '-', { // Added in Tutorial 8
            text: 'Close',
            tooltip: 'Advanced Search',
            handler: closeMaterials,   
            iconCls:'search'
          }, '-', {
            text: 'Print',
        tooltip: 'Print me!',
            handler: printListing, 
            iconCls:'print'
          }
      ]
    });
  MaterialsGrid.addListener('rowcontextmenu', onClientListingEditorGridContextMenu);
  MaterialsGrid.on('afteredit', saveMaterial);
// End of Materials Grid
  ClientListingWindow = new Ext.Window({
      id: 'ClientListingWindow',
      title: 'Clients',
      closable:false,
      width:700,
      height:350,
      plain:true,
	  layout: 'fit',
      items: ClientListingEditorGrid
    });
    
  MaterialsWindow = new Ext.Window({
      id: 'MaterialsWindow',
      title: 'Materials',
      closable:false,
      width:300,
	  modal:true,
      height:350,
      plain:true,
	  layout: 'fit',
      items: MaterialsGrid
    });

  ClientsTypesDataStore.load({params: {start: 0, limit: 15}});
  CitiesDataStore.load({params: {start: 0}});
  ClientsDataStore.load({params: {start: 0, limit: 15}});
  ClientListingWindow.show();
  ClientListingEditorGrid.on('afteredit', saveTheClient);
  
  NameField = new Ext.form.TextField({
    id: 'NameField',
    fieldLabel: 'Name',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  ClientIdField = new Ext.form.TextField({
    id: 'ClientIdField',
    fieldLabel: 'ClientIdField',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  ContactPersonField = new Ext.form.TextField({
    id: 'ContactPersonField',
    fieldLabel: 'ContactPerson',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  AddressField = new Ext.form.TextArea({
    id: 'AddressField',
    fieldLabel: 'Address',
    allowBlank: false,
    anchor : '95%',    
    maskRe: /([a-zA-Z0-9\s]+)$/  
      });

  TelephoneField = new Ext.form.TextField({
    id: 'TelephoneField',
    fieldLabel: 'Telephone',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  MobileField = new Ext.form.TextField({
    id: 'MobileField',
    fieldLabel: 'Mobile',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  FaxField = new Ext.form.TextField({
    id: 'FaxField',
    fieldLabel: 'Fax',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  WebSiteField = new Ext.form.TextField({
    id: 'WebSiteField',
    fieldLabel: 'WebSite',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });

  EmailField = new Ext.form.TextField({
    id: 'EmailField',
    fieldLabel: 'Email',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });

  NotesField = new Ext.form.TextArea({
    id: 'NotesField',
    fieldLabel: 'Notes',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/  
      });
  
  SalesField = new Ext.form.NumberField({
    id:'SalesField',
    fieldLabel: 'Sales',
    allowNegative: false,
    allowBlank: false,
    anchor:'95%'
    });
  
  ClientsTypesField = new Ext.form.ComboBox({
     id:'ClientsTypesField',
     fieldLabel: 'Type',
     store:ClientsTypesDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'IDType',
     anchor:'95%',
     triggerAction: 'all'
      });
  
  CitiesField = new Ext.form.ComboBox({
     id:'CitiesField',
     fieldLabel: 'City',
     store:CitiesDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'IDCity',
     anchor:'95%',
     triggerAction: 'all'
      });

  QtyField = new Ext.form.NumberField({
    id:'QtyField',
    fieldLabel: 'Quantity',
    allowNegative: false,
    allowBlank: false,
    anchor:'95%'
    });
  
  SupplierField = new Ext.form.ComboBox({
     id:'SupplierField',
     fieldLabel: 'Supplier',
     store:SuppliersDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'Id',
     anchor:'95%',
     triggerAction: 'all'
      });
  
  MaterialField = new Ext.form.ComboBox({
     id:'MaterialsField',
     fieldLabel: 'Material',
     store:ProductsDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'Id',
     anchor:'95%',
     triggerAction: 'all'
      });



 NameField2 = new Ext.form.TextField({
    id: 'NameField2',
    fieldLabel: 'Name',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  ClientIdField2 = new Ext.form.TextField({
    id: 'ClientIdField2',
    fieldLabel: 'ClientIdField',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  ContactPersonField2 = new Ext.form.TextField({
    id: 'ContactPersonField2',
    fieldLabel: 'ContactPerson',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  AddressField2 = new Ext.form.TextArea({
    id: 'AddressField2',
    fieldLabel: 'Address',
    allowBlank: false,
    anchor : '95%',    
    maskRe: /([a-zA-Z0-9\s]+)$/  
      });

  TelephoneField2 = new Ext.form.TextField({
    id: 'TelephoneField2',
    fieldLabel: 'Telephone',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  MobileField2 = new Ext.form.TextField({
    id: 'MobileField2',
    fieldLabel: 'Mobile',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  FaxField2 = new Ext.form.TextField({
    id: 'FaxField2',
    fieldLabel: 'Fax',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  WebSiteField2 = new Ext.form.TextField({
    id: 'WebSiteField2',
    fieldLabel: 'WebSite',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });

  EmailField2 = new Ext.form.TextField({
    id: 'EmailField2',
    fieldLabel: 'Email',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });

  NotesField2 = new Ext.form.TextArea({
    id: 'NotesField2',
    fieldLabel: 'Notes',
    allowBlank: false,
    anchor : '95%'  
    //maskRe: /([a-zA-Z0-9\s]+)$/  
      });
  
  SalesField2 = new Ext.form.NumberField({
    id:'SalesField2',
    fieldLabel: 'Sales',
    allowNegative: false,
    allowBlank: false,
    anchor:'95%'
    });
  
  ClientsTypesField2 = new Ext.form.ComboBox({
     id:'ClientsTypesField2',
     fieldLabel: 'Type',
     store:ClientsTypesDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'IDType',
     anchor:'95%',
     triggerAction: 'all'
      });
  
  CitiesField2 = new Ext.form.ComboBox({
     id:'CitiesField',
     fieldLabel: 'City',
     store:CitiesDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'IDCity',
     anchor:'95%',
     triggerAction: 'all'
      });
  
  ClientCreateForm = new Ext.FormPanel({
        labelAlign: 'top',
        bodyStyle:'padding:5px',
        width: 600,   
		height:950,
		items: [{
            layout:'column',
            border:false,
            items:[{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [NameField2, ClientsTypesField2, SalesField2,WebSiteField2,EmailField2,NotesField2]
            },{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [ContactPersonField2,CitiesField2,AddressField2,TelephoneField2,MobileField2,FaxField2]
            }]
        }],
    buttons: [{
      text: 'Save and Close',
      handler: createTheClient
    },{
      text: 'Cancel',
      handler: function(){
        // because of the global vars, we can only instantiate one window... so let's just hide it.
        ClientCreateWindow.hide();
      }
    }]
    });

  ClientCreateWindow= new Ext.Window({
      id: 'ClientCreateWindow',
      title: 'Creating a New Client',
      closable:false,
	  modal:true,
      width: 610,
      height: 410,
      plain:true,
      layout: 'fit',
      items: ClientCreateForm
    });
  
   EditForm = new Ext.FormPanel({
        labelAlign: 'top',
		id:'EditForm',
        bodyStyle:'padding:5px',
        width: 600,   
		height:950,
		items: [{
            layout:'column',
            border:false,
            items:[{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [NameField, ClientsTypesField, SalesField,WebSiteField,EmailField,NotesField]
            },{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [ContactPersonField,CitiesField,AddressField,TelephoneField,MobileField,FaxField]
            }]
        }],
    buttons: [{
      text: 'Save and Close',
      handler: updateTheClient
    },{
      text: 'Cancel',
      handler: function(){
        // because of the global vars, we can only instantiate one window... so let's just hide it.
        ClientEditWindow.hide();
      }
    }]
    });
  
  ClientEditWindow= new Ext.Window({
      id: 'ClientEditWindow',
      title: 'Edit a Client',
	  modal:true,
      closable:false,
      width: 610,
      height: 410,
      plain:true,
      layout: 'fit',
      items: EditForm
    });
  
  AddMaterialForm = new Ext.FormPanel({
        labelAlign: 'top',
        bodyStyle:'padding:5px',
        width: 200,   
		height:250,
		items: [{
            layout:'column',
            border:false,
            items:[{
                columnWidth:1,
                layout: 'form',
                border:false,
                items: [MaterialField,SupplierField,QtyField]
            }]
        }],
    buttons: [{
      text: 'Save and Close',
      handler: addMaterial
    },{
      text: 'Cancel',
      handler: function(){
        // because of the global vars, we can only instantiate one window... so let's just hide it.
        AddMaterialWindow.hide();
      }
    }]
    });

  AddMaterialWindow= new Ext.Window({
      id: 'AddMaterialWindow',
      title: 'Add a Material',
	  modal:true,
      closable:false,
      width: 200,
      height: 250,
      plain:true,
      layout: 'fit',
      items: AddMaterialForm
    });

 
});