// JavaScript Document
Ext.onReady(function(){
   // Menu containing actions
  	Ext.QuickTips.init();

	var tabClients = new Ext.Panel({
    	frame:true,
    	title: 'Clients',
    	collapsible:true,
    	contentEl:'clients',
    	titleCollapse: true
    });
    var tabSuppliers = new Ext.Panel({
    	frame:true,
    	title: 'Suppliers',
    	collapsible:true,
    	contentEl:'suppmenu',
    	titleCollapse: true
    });
    var tabTasks = new Ext.Panel({
    	frame:true,
    	title: 'Tasks',
    	collapsible:true,
    	contentEl:'tasksmenu',
    	titleCollapse: true
    });
    // Parent Panel to hold actions menu
    var actionPanel = new Ext.Panel({
    	id:'action-panel',
    	region:'west',
    	split:true,
    	collapsible: true,
    	collapseMode: 'mini',
		
    	width:200,
    	minWidth: 150,
    	border: false,
    	baseCls:'x-plain',
		layout:'accordion',
		layoutConfig:{animate:true},
    	items: [tabClients,tabSuppliers,tabTasks]
    });
    var headPanel = new Ext.Panel({
    	id:'headPanel',
    	region:'north',
    	collapsible: false,
    	height:105,
		frame:false,
    	border: false,
		items:[{html:'<table width="100%"><tr><td width="10%"><img src="../images/Kaghed22996-FinalLogoD6L2.gif" width="120" height="100" /><td width="80%"><div align="center" class="title1">Staff Zone</div></td></td><td width="10%" align="Right"><a href="logout.php" class="logout">Logout</a></td></tr></table>'}]
    });
 
    // Main (Tabbed) Panel
    var tabPanel = new Ext.Panel({
		region:'center',
		deferredRender:false,
		layout:'fit',
		autoScroll: true, 
		margins:'0 4 4 0'
    });
	
// Adds tab to center panel
    function addTab(tabTitle, targetUrl){
        tabPanel.add({
	    title: tabTitle,
	    iconCls: 'tabs',
	    autoLoad: {url: targetUrl, callback: this.initSearch, scope: this},
	    closable:true
	}).show();
    }
 
    // Update the contents of a tab if it exists, otherwise create a new one
    function updateTab(tabId,title, url) {
    	var tab = tabPanel.getItem(tabId);
    	if(tab){
    		tab.getUpdater().update(url);
    		tab.setTitle(title);
    	}else{
    		tab = addTab(title,url);
    	}
    	tabPanel.setActiveTab(tab);
    }
 
    // Map link ids to functions
    var count = 0;
    var actions = {
    	'newclient' : function(){
    		displayFormWindow();
    	},
    	'deleteclient' : function(){
    		// Toggle between sample pages
    		confirmDeleteClients();	    		
    	},
    	'newsupplier' : function(){
    		// Toggle between sample pages
    		createSupplierFields();
			SupplierCreateWindow.show();	    		
    	},
    	'deletesupplier' : function(){
    		// Toggle between sample pages
    		confirmDeleteSuppliers();	    		
    	},
    	'clientmaterials' : function(){
    		// Toggle between sample pages
    		displayMaterialsWindow();	    		
    	},
		'newtask' : function(){
    		// Toggle between sample pages
    		createAddTaskWindow();	    		
    	},
		'deletetask' : function(){
    		// Toggle between sample pages
    		confirmDeleteTasks();	    		
    	},
		

    };
 
    function doAction(e, t){
    	e.stopEvent();
		var act=Ext.get(t.id)
		if (act){
			if (act.dom.innerHTML=='Clients'){showClients()}
			if (act.dom.innerHTML=='Suppliers'){showSuppliers()}
			if (act.dom.innerHTML=='Tasks'){showTasks()}
			if (t.id.indexOf('ext-gen')) {
				actions[t.id]()}
		}
		
		console.log(t.id);
    };
	

    // Configure viewport
	viewport = new Ext.Viewport({
           layout:'border',
           items:[actionPanel,tabPanel,headPanel]});
	actionPanel.body.on('mousedown', doAction, null);
	//actionPanel.on('mousedown', doAction, null, {delegate:'a'});
    showClients();
	
	function showClients(){
		//tabPanel.renderTo(viewport);
    	ClientsTypesDataStore.load({params: {start: 0, limit: 15}});
    	CitiesDataStore.load({params: {start: 0}});
    	ClientsDataStore.load({params: {start: 0, limit: 15}});
    	//ClientListingEditorGrid.on('afteredit', saveTheClient);
    	var gridsupp = Ext.getCmp('supplierspan');
		if (gridsupp) {
			gridsupp.remove(SupplierListingEditorGrid,false);
		};
    	var gridsupp = Ext.getCmp('tasksspan');
		if (gridsupp) {
			gridsupp.remove(TasksListingEditorGrid,false);
		};

		tabPanel.removeAll();
		tabPanel.add({id:'clientspan',title:'Clients',
		deferredRender:false,
		layout:'fit',
		autoScroll: true, 
		margins:'0 4 4 0',
		items:[ClientListingEditorGrid]});
		tabPanel.doLayout();
		viewport.doLayout();

	};
	
    function showSuppliers(){
  	    SuppliersDataStore.load({params: {start: 0, limit: 15}});
  	    //SupplierListingWindow.show();
  	    //SupplierListingEditorGrid.on('afteredit', saveTheSupplier);
    	var gridcli = Ext.getCmp('clientspan');
		if (gridcli) {
			gridcli.remove(ClientListingEditorGrid,false);
			
		};
    	var gridsupp = Ext.getCmp('tasksspan');
		if (gridsupp) {
			gridsupp.remove(TasksListingEditorGrid,false);
		};
		tabPanel.removeAll();
		tabPanel.add({id:'supplierspan',title:'Suppliers',
		deferredRender:false,
		layout:'fit',
		autoScroll: true, 
		margins:'0 4 4 0',
		items:[SupplierListingEditorGrid]});
		tabPanel.doLayout();
		
    };
    function showTasks(){
  	    createTaskDs();
		StatusDataStore.load({params: {start: 0, limit: 15}});
		StaffDataStore.load({params: {start: 0, limit: 15}});
        TasksDataStore.load({params: {start: 0, limit: 15}});
		createTaskGrid();
    	var gridcli = Ext.getCmp('clientspan');
		if (gridcli) {
			gridcli.remove(ClientListingEditorGrid,false);
			
		};
    	var gridsupp = Ext.getCmp('supplierspan');
		if (gridsupp) {
			gridsupp.remove(SupplierListingEditorGrid,false);
		};
		tabPanel.removeAll();
		tabPanel.add({id:'tasksspan',title:'Tasks',
		deferredRender:false,
		layout:'fit',
		autoScroll: true, 
		margins:'0 4 4 0',
		items:[TasksListingEditorGrid]});
		tabPanel.doLayout();
		
    };
	
	
	
});