// Global vars
var ClientsDataStore;
var ClientsTypesDataStore;
var CitiesDataStore;
var ClientsColumnModel;
var ClientsTypesColumnModel;
var CitiesColumnModel;
var ClientListingEditorGrid;
var ClientListingWindow;
var ClientCreateForm;
var ClientCreateWindow;
var FirstNameField;
var LastNameField;
var EnteringOfficeField;
var LeavingOfficeField;
var IncomeField;
var PartyField;
var ClientListingSelectedRow;
var ClientListingContextMenu;

Ext.onReady(function(){

  Ext.QuickTips.init();
  
  // This saves the Client after a cell has been edited
  function saveTheClient(oGrid_event){
   Ext.Ajax.request({   
      waitMsg: 'Please wait...',
      url: 'database.php',
      params: {
         task: "UPDATECLIENT",
         id: oGrid_event.record.data.IDClient,
         name: oGrid_event.record.data.Name,
         address: oGrid_event.record.data.Address,
         type: oGrid_event.record.data.ClientType,
         city: oGrid_event.record.data.CityId,
         contactperson: oGrid_event.record.data.ContactPerson,
         sales: oGrid_event.record.data.Sales,
		 telephone: oGrid_event.record.data.Telephone,
		 fax: oGrid_event.record.data.Fax,
		 mobile: oGrid_event.record.data.Mobile,
		 website: oGrid_event.record.data.WebSite,
		 email: oGrid_event.record.data.Email
      }, 
      success: function(response){              
         var result=eval(response.responseText);
         switch(result){
         case 1:
            ClientsDataStore.commitChanges();
            ClientsDataStore.reload();
            break;          
         default:
            Ext.MessageBox.alert(response.responseText);
            break;
         }
      },
      failure: function(response){
         var result=response.responseText;
         Ext.MessageBox.alert('error','could not connect to the database. retry later');    
      }                      
   });   
  }

  // this creates a new Client
  function createTheClient(){
     if(isClientFormValid()){
      Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "CREATECLIENT",
          name:      			NameField.getValue(),
          address:       		 AddressField.getValue(),
          type: 				ClientsTypesField.getValue(),
          sales:  			   SalesField.getValue(),
          website:          	 WebSiteField.getValue(),
          email:          	   EmailField.getValue(),
		  notes:          	   NotesField.getValue(),
		  contactperson:	   ContactPersonField.getValue(),
		  city:          	    CitiesField.getValue(),
		  telephone:           TelephoneField.getValue(),
		  mobile:          	  MobileField.getValue(),
		  fax:	          	 FaxField.getValue()
        }, 
        success: function(response){              
          var result=eval(response.responseText);
          switch(result){
          case 1:
            Ext.MessageBox.alert('Creation OK','The Client was created successfully.');
            ClientsDataStore.reload();
            ClientCreateWindow.hide();
            break;
          default:
            Ext.MessageBox.alert(response.responseText);
            break;
          }        
        },
        failure: function(response){
          var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
    } else {
      Ext.MessageBox.alert('Warning', 'Your Form is not valid!');
    }
  }
  
  // reset the Form before opening it
  function resetClientForm(){
    NameField.setValue('');
    AddressField.setValue('');
    NotesField.setValue('');
    EmailField.setValue('');
    SalesField.setValue('');
    WebSiteField.setValue('');    
  }
  
  // check if the form is valid
  function isClientFormValid(){
      return(NameField.isValid() && AddressField.isValid() && ClientsTypesField.isValid() && WebSiteField.isValid() && SalesField.isValid() && CitiesField.isValid() && EmailField.isValid());
  }
  
  // display or bring forth the form
  function displayFormWindow(){
     if(!ClientCreateWindow.isVisible()){
       resetClientForm();
       ClientCreateWindow.show();
     } else {
       ClientCreateWindow.toFront();
     }
  }
  
  // This was added in Tutorial 6
  function confirmDeleteClients(){
    if(ClientListingEditorGrid.selModel.getCount() == 1) // only one Client is selected here
    {
      Ext.MessageBox.confirm('Confirmation','You are about to delete a Client. Continue?', deleteClients);
    } else if(ClientListingEditorGrid.selModel.getCount() > 1){
      Ext.MessageBox.confirm('Confirmation','Delete those Clients?', deleteClients);
    } else {
      Ext.MessageBox.alert('Uh oh...','You can\'t really delete something you haven\'t selected huh?');
    }
  }  
   // This was added in Tutorial 6
  function deleteClients(btn){
    if(btn=='yes'){
         var selections = ClientListingEditorGrid.selModel.getSelections();
         var prez = [];
         for(i = 0; i< ClientListingEditorGrid.selModel.getCount(); i++){
          prez.push(selections[i].json.IDClient);
         }
         var encoded_array = Ext.encode(prez);
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url: 'database.php', 
            params: { 
               task: "DELETECLIENT", 
               ids:  encoded_array
              }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1:  // Success : simply reload
                ClientsDataStore.reload();
                break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }
  
 
  function startAdvancedSearch(){
      // local vars
      var ClientSearchForm;
      var ClientSearchWindow;
      var SearchFirstNameItem;
      var SearchLastNameItem;
      var SearchPartyItem;
      var SearchEnteringItem;
      var SearchLeavingItem;
      
     function listSearch(){
         // render according to a SQL date format.
         var startDate = "";
         var endDate = "";
         if(SearchEnteringItem.getValue() !== "") {
            startDate = SearchEnteringItem.getValue().format('Y-m-d');
         }
         if(SearchLeavingItem.getValue() !== "") {
            endDate = SearchLeavingItem.getValue().format('Y-m-d');
         }
         
         // change the store parameters
        ClientsDataStore.baseParams = {
         task: 'SEARCH',
         firstname: SearchFirstNameItem.getValue(),
            lastname : SearchLastNameItem.getValue(),
            party : SearchPartyItem.getValue(),
            enteringoffice : startDate,
            leavingoffice : endDate
       };
         // Cause the datastore to do another query : 
       ClientsDataStore.reload({params: {start: 0, limit: 15}});
     }
     
     function resetSearch(){
         // reset the store parameters
        ClientsDataStore.baseParams = {
         task: 'LISTING'
       };
         // Cause the datastore to do another query : 
       ClientsDataStore.reload({params: {start: 0, limit: 15}});
         ClientSearchWindow.close();
     }
     
      SearchFirstNameItem = new Ext.form.TextField({
          fieldLabel: 'First Name',
          maxLength: 20,
          anchor : '95%',
          maskRe: /([a-zA-Z0-9\s]+)$/
            });

      SearchLastNameItem = new Ext.form.TextField({
          fieldLabel: 'Last Name',
          maxLength: 20,
          anchor : '95%',    
          maskRe: /([a-zA-Z0-9\s]+)$/  
            });
      
      SearchPartyItem = new Ext.form.ComboBox({
         fieldLabel: 'Party',
         store:new Ext.data.SimpleStore({
          fields:['partyValue', 'partyName'],
          data: [['1','No Party'],['2','Federalist'],['3','Democratic-Republican'],['4','Democratic'],['5','Whig'],['6','Republican']]
          }),
         mode: 'local',
         displayField: 'partyName',
         valueField: 'partyValue',
         anchor:'95%',
         triggerAction: 'all'
            });
            
      SearchEnteringItem = new Ext.form.DateField({
          fieldLabel: 'Entered Office after',
          format : 'm/d/Y',
          anchor:'95%'
          });
          
      SearchLeavingItem = new Ext.form.DateField({
          fieldLabel: 'Left Office before',
          format : 'm/d/Y',
          anchor:'95%'
          });
    
     ClientSearchForm = new Ext.FormPanel({
       //labelAlign: 'top',
       bodyStyle: 'padding: 5px',
       width: 300,
       items: [{
         layout: 'form',
         border: false,
         items: [ SearchFirstNameItem,SearchLastNameItem,SearchPartyItem,SearchEnteringItem, SearchLeavingItem ],
         buttons: [{
               text: 'Search',
               handler: listSearch
             },{
               text: 'Close',
               handler: resetSearch
             }]
         }]
     });
 
     
     ClientSearchWindow = new Ext.Window({
         title: 'Client Search',
         closable:true,
         width: 200,
         height: 400,
         plain:true,
         layout: 'fit',
         items: ClientSearchForm
     });
 
     
     // once all is done, show the search window
     ClientSearchWindow.show();
  } 
  
    function printListing(){
      var searchquery = "";
      var searchfirstname = "";
      var searchlastname = "";
      var searchparty = "";
      var searchenteringoffice = "";
      var searchleavingoffice = "";
      var win;               // our popup window
      // check if we do have some search data...
      if(ClientsDataStore.baseParams.query!==null){searchquery = ClientsDataStore.baseParams.query;}
      if(ClientsDataStore.baseParams.firstname!==null){searchfirstname = ClientsDataStore.baseParams.firstname;}
      if(ClientsDataStore.baseParams.lastname!==null){searchlastname = ClientsDataStore.baseParams.lastname;}
      if(ClientsDataStore.baseParams.party!==null){searchparty = ClientsDataStore.baseParams.party;}
      if(ClientsDataStore.baseParams.enteringoffice!==null){searchenteringoffice = ClientsDataStore.baseParams.enteringoffice;}
      if(ClientsDataStore.baseParams.leavingoffice!==null){searchleavingoffice = ClientsDataStore.baseParams.leavingoffice;}
         
      Ext.Ajax.request({   
        waitMsg: 'Please Wait...',
        url: 'database.php',
        params: {
          task: "PRINT",
               // we have to send all of the search

          query: searchquery,                                 // if we are doing a quicksearch, use this
          firstname : searchfirstname,                        // if we are doing advanced search, use this
          lastname : searchlastname,
          party : searchparty,
          enteringoffice : searchenteringoffice,
          leavingoffice : searchleavingoffice,
          currentlisting: ClientsDataStore.baseParams.task // this tells us if we are searching or not
        }, 
        success: function(response){              
          var result=eval(response.responseText);
          switch(result){
          case 1:
            win = window.open('./Clientslist.html','Clientslist','height=400,width=600,resizable=1,scrollbars=1, menubar=1');
            win.print();
            break;
          default:
            Ext.MessageBox.alert('Uh hu...','Unable to print the grid!');
            break;
          }  
        },
        failure: function(response){
          var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');      
        }                      
      });
  }
 
  function onClientListingEditorGridContextMenu(grid, rowIndex, e) {
    e.stopEvent();
    var coords = e.getXY();
    ClientListingContextMenu.rowRecord = grid.store.getAt(rowIndex);
    grid.selModel.selectRow(rowIndex);
    ClientListingSelectedRow=rowIndex;
    ClientListingContextMenu.showAt([coords[0], coords[1]]);
  }
 
  function modifyClientContextMenu(){
      ClientListingEditorGrid.startEditing(ClientListingSelectedRow,1);
  }

  function deleteClientContextMenu(){
      confirmDeleteClients();
  }

  function printListingContextMenu(){
      printListing();
  }

  
  // << CONFIG >>
  ClientsDataStore = new Ext.data.Store({
      id: 'ClientsDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTING"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'id'
      },[ 
        {name: 'IDClient', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'},
        {name: 'Address', type: 'string', mapping: 'Address'},
        {name: 'ClientType', type: 'string', mapping: 'Type'},
        {name: 'CityId', type: 'string', mapping: 'City'},
        {name: 'ContactPerson', type: 'string', mapping: 'ContactPerson'},
        {name: 'Sales', type: 'float', mapping: 'Sales'},
		{name: 'Telephone', type: 'string', mapping: 'Telephone'},
        {name: 'Fax', type: 'string', mapping: 'Fax'},
		{name: 'Mobile', type: 'string', mapping: 'Mobile'},
		{name: 'WebSite', type: 'string', mapping: 'WebSite'},
		{name: 'Email', type: 'string', mapping: 'Email'}
      ]),
      sortInfo:{field: 'IDClient', direction: "ASC"}
    });
  
  ClientsTypesDataStore = new Ext.data.Store({
      id: 'ClientsTypesDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "TYPES"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'id'
      },[ 
        {name: 'IDType', type: 'int', mapping: 'id'},
        {name: 'Name', type: 'string', mapping: 'name'}
      ]),
      sortInfo:{field: 'Name', direction: "ASC"}
    });
  
  CitiesDataStore = new Ext.data.Store({
      id: 'CitiesDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "CITIES"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'IDCity', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'}
      ]),
      sortInfo:{field: 'Name', direction: "ASC"}
    });
    
  ClientsColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'IDClient',
        width: 40,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Name',
        dataIndex: 'Name',
        width: 60,
        editor: new Ext.form.TextField({
            allowBlank: false,
            maxLength: 20,
            maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Address',
        dataIndex: 'Address',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      },{
        header: 'City',
        dataIndex: 'CityId',
        width: 80,
        editor: new Ext.form.ComboBox({
          store:CitiesDataStore,
     	  mode: 'local',
     	  displayField: 'Name',
     	  allowBlank: false,
          valueField: 'IDCity',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(data,value, cell){ 
			record = CitiesDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.Name;
            } else {
                                    //return data;
                return 'Invalid city';
            }        }
      },{
        header: 'Client Type',
        dataIndex: 'ClientType',
        width: 80,
        editor: new Ext.form.ComboBox({
          store:ClientsTypesDataStore,
     	  mode: 'local',
     	  displayField: 'Name',
     	  allowBlank: false,
          valueField: 'IDType',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(data,value, cell){ 
			record = ClientsTypesDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.Name;
            } else {
                                    //return data;
                return data;
            }        }
      },{
        header: 'Contact Person',
        dataIndex: 'ContactPerson',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      },{
        header: "Sales",
        dataIndex: 'Sales',
        width: 100,
        renderer: function(value, cell){ 
         var str = '';
         if(value > 1000000){
            str = "<span style='color:#336600;'>$ " + value + "</span>";
         } else if (value > 100000 && value < 1000000){
            str = "<span style='color:#FF9900;'>$ " + value + "</span>";
         } else {
            str = "<span style='color:#CC0000;'>$ " + value + "</span>";
         }
         return str; 
        },
        editor: new Ext.form.NumberField({
          allowBlank: false,
          allowDecimals: true,
          allowNegative: false,
          blankText: '0',
          maxLength: 11
          })
      },{
        header: 'Telephone',
        dataIndex: 'Telephone',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Fax',
        dataIndex: 'Fax',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Mobile',
        dataIndex: 'Mobile',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Website',
        dataIndex: 'WebSite',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Email',
        dataIndex: 'Email',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         cell.css = "coolcell";
         return value;
        }
      }]
    );
    ClientsColumnModel.defaultSortable= true;
    
  ClientsTypesColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'IDType',
        width: 20,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Type',
        readOnly: true,
        dataIndex: 'Name',
        width: 40,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      }]
  );
  ClientsTypesColumnModel.defaultSortable= true;

  CitiesColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'IDCity',
        width: 20,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'City',
        readOnly: true,
        dataIndex: 'Name',
        width: 40,        
        renderer: function(value, cell){ 
         cell.css = "readonlycell";
         return value;
        },
        hidden: false
      }]
  );
  CitiesColumnModel.defaultSortable= true;

  ClientListingEditorGrid =  new Ext.grid.EditorGridPanel({
      id: 'ClientListingEditorGrid',
      store: ClientsDataStore,
      cm: ClientsColumnModel,
      enableColLock:false,
      clicksToEdit:2,
      selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
      bbar: new Ext.PagingToolbar({
                pageSize: 15,
                store: ClientsDataStore,
                displayInfo: true
            }),
      tbar: [
          {
            text: 'Client\'s Materials',
            tooltip: 'Great tooltips...',
            iconCls:'add',                      // reference to our css
            handler: displayFormWindow
          },'-',{
            text: 'Add a Client',
            tooltip: 'Great tooltips...',
            iconCls:'add',                      // reference to our css
            handler: displayFormWindow
          }, '-', { 
            text: 'Delete selection',
            tooltip: 'Jose, can you seeeee??',
            handler: confirmDeleteClients,   // Confirm before deleting
            iconCls:'remove'
          }, '-', { // Added in Tutorial 8
            text: 'Search',
            tooltip: 'Advanced Search',
            handler: startAdvancedSearch,   
            iconCls:'search'
          }, '-', new Ext.app.SearchField({
                    store: ClientsDataStore,
            params: {start: 0, limit: 15},
                    width: 120
        }),'-', {
            text: 'Print',
        tooltip: 'Print me!',
            handler: printListing, 
            iconCls:'print'
          }
      ]
    });
  ClientListingEditorGrid.addListener('rowcontextmenu', onClientListingEditorGridContextMenu);

  ClientListingContextMenu = new Ext.menu.Menu({
      id: 'ClientListingEditorGridContextMenu',
      items: [
      { text: 'Modify this Client', handler: modifyClientContextMenu },
      { text: 'Delete this Client', handler: deleteClientContextMenu },
      '-',
      { text: 'Print this grid', handler: printListingContextMenu }
      ]
   });    
    
  ClientListingWindow = new Ext.Window({
      id: 'ClientListingWindow',
      title: 'Clients',
      closable:false,
      width:700,
      height:350,
      plain:true,
	  layout: 'fit',
      items: ClientListingEditorGrid
    });
    
  ClientsTypesDataStore.load({params: {start: 0, limit: 15}});
  CitiesDataStore.load({params: {start: 0}});
  ClientsDataStore.load({params: {start: 0, limit: 15}});
  ClientListingWindow.show();
  ClientListingEditorGrid.on('afteredit', saveTheClient);
  
  NameField = new Ext.form.TextField({
    id: 'FirstNameField',
    fieldLabel: 'Name',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  ContactPersonField = new Ext.form.TextField({
    id: 'ContactPersonField',
    fieldLabel: 'ContactPerson',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  AddressField = new Ext.form.TextArea({
    id: 'AddressField',
    fieldLabel: 'Address',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',    
    maskRe: /([a-zA-Z0-9\s]+)$/  
      });

  TelephoneField = new Ext.form.TextField({
    id: 'TelephoneField',
    fieldLabel: 'Telephone',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  MobileField = new Ext.form.TextField({
    id: 'MobileField',
    fieldLabel: 'Mobile',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  FaxField = new Ext.form.TextField({
    id: 'FaxField',
    fieldLabel: 'Fax',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  WebSiteField = new Ext.form.TextField({
    id: 'WebSiteField',
    fieldLabel: 'WebSite',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  EmailField = new Ext.form.TextField({
    id: 'EmailField',
    fieldLabel: 'Email',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  NotesField = new Ext.form.TextArea({
    id: 'NotesField',
    fieldLabel: 'Notes',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',    
    maskRe: /([a-zA-Z0-9\s]+)$/  
      });
  
  SalesField = new Ext.form.NumberField({
    id:'SalesField',
    fieldLabel: 'Sales',
    allowNegative: false,
    allowBlank: false,
    anchor:'95%'
    });
  
  ClientsTypesField = new Ext.form.ComboBox({
     id:'ClientsTypesField',
     fieldLabel: 'Type',
     store:ClientsTypesDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'IDType',
     anchor:'95%',
     triggerAction: 'all'
      });
  
  CitiesField = new Ext.form.ComboBox({
     id:'CitiesField',
     fieldLabel: 'City',
     store:CitiesDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'IDCity',
     anchor:'95%',
     triggerAction: 'all'
      });

  ClientCreateForm = new Ext.FormPanel({
        labelAlign: 'top',
        bodyStyle:'padding:5px',
        width: 600,   
		height:950,
		items: [{
            layout:'column',
            border:false,
            items:[{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [NameField, ClientsTypesField, SalesField,WebSiteField,EmailField,NotesField]
            },{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [ContactPersonField,CitiesField,AddressField,TelephoneField,MobileField,FaxField]
            }]
        }],
    buttons: [{
      text: 'Save and Close',
      handler: createTheClient
    },{
      text: 'Cancel',
      handler: function(){
        // because of the global vars, we can only instantiate one window... so let's just hide it.
        ClientCreateWindow.hide();
      }
    }]
    });
  
  ClientCreateWindow= new Ext.Window({
      id: 'ClientCreateWindow',
      title: 'Creating a New Client',
      closable:true,
      width: 610,
      height: 410,
      plain:true,
      layout: 'fit',
      items: ClientCreateForm
    });
  
  
});