// Global vars
var SuppliersDataStore;
var SuppliersColumnModel;
var SupplierListingEditorGrid;
var SupplierListingWindow;
var SupplierCreateForm;
var SupplierCreateWindow;
var FirstNameField;
var LastNameField;
var EnteringOfficeField;
var LeavingOfficeField;
var IncomeField;
var PartyField;
var SupplierListingSelectedRow;
var SupplierListingContextMenu;

  
  // This saves the Supplier after a cell has been edited

  // this creates a new Supplier
  function createTheSupplier(){
     if(isSupplierFormValid()){
      Ext.MessageBox.wait('Updating!', 'Please Wait ...');
	  Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "CREATESUPP",
          name:      			NameField2.getValue(),
          address:       		 AddressField2.getValue(),
          website:          	 WebSiteField2.getValue(),
          email:          	   EmailField2.getValue(),
		  telephone:           TelephoneField2.getValue(),
		  mobile:          	  MobileField2.getValue(),
		  fax:	          	 FaxField2.getValue()
        }, 
        success: function(response){              
          var result=eval(response.responseText);
          switch(result){
          case 1:
            Ext.MessageBox.hide();
			Ext.MessageBox.alert('Creation OK','The Supplier was created successfully.');
            SuppliersDataStore.reload();
            SupplierCreateWindow.hide();
            break;
          default:
            Ext.MessageBox.hide();
			Ext.MessageBox.alert('Could not update the supplier');
            break;
          }        
        },
        failure: function(response){
          Ext.MessageBox.hide();
		  var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
    } else {
      Ext.MessageBox.hide();
	  Ext.MessageBox.alert('Warning', 'Your Form is not valid!');
    }
  }
  
  function updateTheSupplier(){
     if(isSupplierFormValid()){
      Ext.MessageBox.wait('Updating!', 'Please Wait ...');
	  Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "UPDATESUPP",
          id: 				  SupplierIdField.getValue(),
		  name:      			NameField.getValue(),
          address:       		 AddressField.getValue(),
          website:          	 WebSiteField.getValue(),
          email:          	   EmailField.getValue(),
		  telephone:           TelephoneField.getValue(),
		  mobile:          	  MobileField.getValue(),
		  fax:	          	 FaxField.getValue()
        }, 
        success: function(response){              
          var result=eval(response.responseText);
          console.log(result);
		  switch(result){
          case 0:
		  case 1:
            Ext.MessageBox.hide();
			Ext.MessageBox.alert('Update OK','The Supplier was updated successfully.');
            SuppliersDataStore.reload();
			SupplierEditWindow.hide();
            break;
          default:
            Ext.MessageBox.hide();
			Ext.MessageBox.alert('Could not update the supplier');
            break;
          }        
        },
        failure: function(response){
          Ext.MessageBox.hide();
		  var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
    } else {
      Ext.MessageBox.hide();
	  Ext.MessageBox.alert('Warning', 'Your Form is not valid!');
	  console.log(response.responseText);
    }
  }
  // reset the Form before opening it
  function resetSupplierForm(){
    NameField.setValue('');
    AddressField.setValue('');
    EmailField.setValue('');
    WebSiteField.setValue('');    
  }
  function fillSupplierForm(rec){
	SupplierIdField.setValue(rec.get('IDSupplier'));
    NameField.setValue(rec.get('Name'));
    AddressField.setValue(rec.get('Address'));
    EmailField.setValue(rec.get('Email'));
    WebSiteField.setValue(rec.get('WebSite'));
	MobileField.setValue(rec.get('Mobile'));
	TelephoneField.setValue(rec.get('Telephone'));
	FaxField.setValue(rec.get('Fax'));
  }
  
  // check if the form is valid
  function isSupplierFormValid(){
      return(true);
  }
  
  // display or bring forth the form
  function displaySuppFormWindow(){
     createSupplierFields();
	 if(!SupplierCreateWindow.isVisible()){
       resetSupplierForm();
       SupplierCreateWindow.show();
	   //SupplierCreateWindow.toFront();
     } else {
       SupplierCreateWindow.toFront();
     }
  }
  function editSuppFormWindow(rec){
	createEditSuppForm();
	if(!SupplierEditWindow.isVisible()){
       fillSupplierForm(rec);
       SupplierEditWindow.show();
     } else {
       SupplierEditWindow.toFront();
     }
  }
  
  // This was added in Tutorial 6
  function confirmDeleteSuppliers(){
    if(SupplierListingEditorGrid.selModel.getCount() == 1) // only one Supplier is selected here
    {
      Ext.MessageBox.confirm('Confirmation','You are about to delete a Supplier. Continue?', deleteSuppliers);
    } else if(SupplierListingEditorGrid.selModel.getCount() > 1){
      Ext.MessageBox.confirm('Confirmation','Delete those Suppliers?', deleteSuppliers);
    } else {
      Ext.MessageBox.alert('Error','Please select a supplier to delete?');
    }
  }  
   // This was added in Tutorial 6
  function deleteSuppliers(btn){
    if(btn=='yes'){
         var selections = SupplierListingEditorGrid.selModel.getSelections();
         var prez = [];
         for(i = 0; i< SupplierListingEditorGrid.selModel.getCount(); i++){
          prez.push(selections[i].data['IDSupplier']);
         }
         var encoded_array = Ext.encode(prez);
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url: 'database.php', 
            params: { 
               task: "DELETESUPP", 
               ids:  encoded_array
              }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1:  // Success : simply reload
                SuppliersDataStore.reload();
                break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }
  
/* 
  function startAdvancedSearch(){
      // local vars
      var SupplierSearchForm;
      var SupplierSearchWindow;
      var SearchFirstNameItem;
      var SearchLastNameItem;
      var SearchPartyItem;
      var SearchEnteringItem;
      var SearchLeavingItem;
      
     function listSearch(){
         // render according to a SQL date format.
         var startDate = "";
         var endDate = "";
         if(SearchEnteringItem.getValue() !== "") {
            startDate = SearchEnteringItem.getValue().format('Y-m-d');
         }
         if(SearchLeavingItem.getValue() !== "") {
            endDate = SearchLeavingItem.getValue().format('Y-m-d');
         }
         
         // change the store parameters
        SuppliersDataStore.baseParams = {
         task: 'SEARCH',
         firstname: SearchFirstNameItem.getValue(),
            lastname : SearchLastNameItem.getValue(),
            party : SearchPartyItem.getValue(),
            enteringoffice : startDate,
            leavingoffice : endDate
       };
         // Cause the datastore to do another query : 
       SuppliersDataStore.reload({params: {start: 0, limit: 15}});
     }
     
     function resetSearch(){
         // reset the store parameters
        SuppliersDataStore.baseParams = {
         task: 'LISTING'
       };
         // Cause the datastore to do another query : 
       SuppliersDataStore.reload({params: {start: 0, limit: 15}});
         SupplierSearchWindow.close();
     }
     
      SearchFirstNameItem = new Ext.form.TextField({
          fieldLabel: 'First Name',
          maxLength: 20,
          anchor : '95%',
          maskRe: /([a-zA-Z0-9\s]+)$/
            });

      SearchLastNameItem = new Ext.form.TextField({
          fieldLabel: 'Last Name',
          maxLength: 20,
          anchor : '95%',    
          maskRe: /([a-zA-Z0-9\s]+)$/  
            });
      
      SearchPartyItem = new Ext.form.ComboBox({
         fieldLabel: 'Party',
         store:new Ext.data.SimpleStore({
          fields:['partyValue', 'partyName'],
          data: [['1','No Party'],['2','Federalist'],['3','Democratic-Republican'],['4','Democratic'],['5','Whig'],['6','Republican']]
          }),
         mode: 'local',
         displayField: 'partyName',
         valueField: 'partyValue',
         anchor:'95%',
         triggerAction: 'all'
            });
            
      SearchEnteringItem = new Ext.form.DateField({
          fieldLabel: 'Entered Office after',
          format : 'm/d/Y',
          anchor:'95%'
          });
          
      SearchLeavingItem = new Ext.form.DateField({
          fieldLabel: 'Left Office before',
          format : 'm/d/Y',
          anchor:'95%'
          });
    
     SupplierSearchForm = new Ext.FormPanel({
       //labelAlign: 'top',
       bodyStyle: 'padding: 5px',
       width: 300,
       items: [{
         layout: 'form',
         border: false,
         items: [ SearchFirstNameItem,SearchLastNameItem,SearchPartyItem,SearchEnteringItem, SearchLeavingItem ],
         buttons: [{
               text: 'Search',
               handler: listSearch
             },{
               text: 'Close',
               handler: resetSearch
             }]
         }]
     });
 
     
     SupplierSearchWindow = new Ext.Window({
         title: 'Supplier Search',
         closable:true,
         width: 200,
         height: 400,
         plain:true,
         layout: 'fit',
         items: SupplierSearchForm
     });
 
     
     // once all is done, show the search window
     SupplierSearchWindow.show();
  } 
*/  
    function printListing(){
      var searchquery = "";
      var searchfirstname = "";
      var searchlastname = "";
      var searchparty = "";
      var searchenteringoffice = "";
      var searchleavingoffice = "";
      var win;               // our popup window
      // check if we do have some search data...
      if(SuppliersDataStore.baseParams.query!==null){searchquery = SuppliersDataStore.baseParams.query;}
      if(SuppliersDataStore.baseParams.firstname!==null){searchfirstname = SuppliersDataStore.baseParams.firstname;}
      if(SuppliersDataStore.baseParams.lastname!==null){searchlastname = SuppliersDataStore.baseParams.lastname;}
      if(SuppliersDataStore.baseParams.party!==null){searchparty = SuppliersDataStore.baseParams.party;}
      if(SuppliersDataStore.baseParams.enteringoffice!==null){searchenteringoffice = SuppliersDataStore.baseParams.enteringoffice;}
      if(SuppliersDataStore.baseParams.leavingoffice!==null){searchleavingoffice = SuppliersDataStore.baseParams.leavingoffice;}
         
      Ext.Ajax.request({   
        waitMsg: 'Please Wait...',
        url: 'database.php',
        params: {
          task: "PRINT",
               // we have to send all of the search

          query: searchquery,                                 // if we are doing a quicksearch, use this
          firstname : searchfirstname,                        // if we are doing advanced search, use this
          lastname : searchlastname,
          party : searchparty,
          enteringoffice : searchenteringoffice,
          leavingoffice : searchleavingoffice,
          currentlisting: SuppliersDataStore.baseParams.task // this tells us if we are searching or not
        }, 
        success: function(response){              
          var result=eval(response.responseText);
          switch(result){
          case 1:
            win = window.open('./Supplierslist.html','Supplierslist','height=400,width=600,resizable=1,scrollbars=1, menubar=1');
            win.print();
            break;
          default:
            Ext.MessageBox.alert('Uh hu...','Unable to print the grid!');
            break;
          }  
        },
        failure: function(response){
          var result=response.responseText;
          Ext.MessageBox.alert('error','could not connect to the database. retry later');      
        }                      
      });
  }
 
  function onSupplierListingEditorGridContextMenu(grid, rowIndex, e) {
    e.stopEvent();
    var coords = e.getXY();
    SupplierListingContextMenu.rowRecord = grid.store.getAt(rowIndex);
    grid.selModel.selectRow(rowIndex);
    SupplierListingSelectedRow=rowIndex;
    SupplierListingContextMenu.showAt([coords[0], coords[1]]);
  }
 
  function modifySupplierContextMenu(){
      SupplierListingEditorGrid.startEditing(SupplierListingSelectedRow,1);
  }

  function deleteSupplierContextMenu(){
      confirmDeleteSuppliers();
  }

  function printListingContextMenu(){
      printListing();
  }

  
  // << CONFIG >>
  SuppliersDataStore = new Ext.data.Store({
      id: 'SuppliersDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTSUPP"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'IDSupplier', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'},
        {name: 'Address', type: 'string', mapping: 'Address'},
		{name: 'Telephone', type: 'string', mapping: 'Telephone'},
        {name: 'Fax', type: 'string', mapping: 'Fax'},
		{name: 'Mobile', type: 'string', mapping: 'Mobile'},
		{name: 'WebSite', type: 'string', mapping: 'Website'},
		{name: 'Email', type: 'string', mapping: 'Email'}
      ]),
      sortInfo:{field: 'IDSupplier', direction: "ASC"}
    });
  
    
  SuppliersColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'IDSupplier',
        width: 40,        
        renderer: function(value, cell){ 
         //cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Name',
        dataIndex: 'Name',
        width: 60,
        editor: new Ext.form.TextField({
            allowBlank: false,
            maxLength: 20,
            maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Address',
        dataIndex: 'Address',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Telephone',
        dataIndex: 'Telephone',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Fax',
        dataIndex: 'Fax',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Mobile',
        dataIndex: 'Mobile',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Website',
        dataIndex: 'WebSite',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      },{
        header: 'Email',
        dataIndex: 'Email',
        width: 80,
        editor: new Ext.form.TextField({
          allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell){ 
         //cell.css = "coolcell";
         return value;
        }
      }]
    );
    SuppliersColumnModel.defaultSortable= true;
    
  SupplierListingEditorGrid =  new Ext.grid.EditorGridPanel({
      id: 'SupplierListingEditorGrid',
      store: SuppliersDataStore,
      cm: SuppliersColumnModel,
      enableColLock:false,
      clicksToEdit:3,
      selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
      bbar: new Ext.PagingToolbar({
                pageSize: 15,
                store: SuppliersDataStore,
                displayInfo: true
            }),
      tbar: [
          {
            text: 'Add a Supplier',
            tooltip: 'Great tooltips...',
            iconCls:'add',                      // reference to our css
            handler: displaySuppFormWindow
          }, '-', { 
            text: 'Delete selection',
            tooltip: 'Delete Suppliers',
            handler: confirmDeleteSuppliers,   // Confirm before deleting
            iconCls:'remove'
          }, '-', { // Added in Tutorial 8
            text: 'Search',
            tooltip: 'Advanced Search',
            //handler: startAdvancedSearch,   
            iconCls:'search'
          }, '-', new Ext.app.SearchField({
                    store: SuppliersDataStore,
            params: {start: 0, limit: 15},
                    width: 120
        }),'-', {
            text: 'Print',
        tooltip: 'Print me!',
            handler: printListing, 
            iconCls:'print'
          }
      ]
    });
  SupplierListingEditorGrid.addListener('rowcontextmenu', onSupplierListingEditorGridContextMenu);
  SupplierListingEditorGrid.on('rowdblclick', function(grid, rowIndex) {
         var record = grid.store.getAt(rowIndex);
         if (record) {
                //console.info('You selected ' + record.get('AufgabenNr'));
				editSuppFormWindow(record);
         }
        

    });
   
  SupplierListingContextMenu = new Ext.menu.Menu({
      id: 'SupplierListingEditorGridContextMenu',
      items: [
      { text: 'Modify this Supplier', handler: modifySupplierContextMenu },
      { text: 'Delete this Supplier', handler: deleteSupplierContextMenu },
      '-',
      { text: 'Print this grid', handler: printListingContextMenu }
      ]
   });    

  SupplierListWindow= new Ext.Window({
      id: 'SupplierListWindow',
      title: 'Creating a New Supplier',
      closable:false,
      width: 610,
      height: 320,
	  modal:true,
      plain:true,
      layout: 'fit',
      items: SupplierListingEditorGrid
    });

  SupplierIdField = new Ext.form.TextField({
    id: 'SupplierIdField',
    fieldLabel: 'SupplierIdField',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });
function createSupplierFields(){
 NameField2 = new Ext.form.TextField({
    id: 'NameField2',
    fieldLabel: 'Name',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });
  AddressField2 = new Ext.form.TextArea({
    id: 'AddressField2',
    fieldLabel: 'Address',
    allowBlank: false,
    anchor : '95%',    
    maskRe: /([a-zA-Z0-9\s]+)$/  
      });

  TelephoneField2 = new Ext.form.TextField({
    id: 'TelephoneField2',
    fieldLabel: 'Telephone',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  MobileField2 = new Ext.form.TextField({
    id: 'MobileField2',
    fieldLabel: 'Mobile',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  FaxField2 = new Ext.form.TextField({
    id: 'FaxField2',
    fieldLabel: 'Fax',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  WebSiteField2 = new Ext.form.TextField({
    id: 'WebSiteField2',
    fieldLabel: 'WebSite',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });

  EmailField2 = new Ext.form.TextField({
    id: 'EmailField2',
    fieldLabel: 'Email',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });

  SupplierIdField2 = new Ext.form.TextField({
    id: 'SupplierIdField2',
    fieldLabel: 'SupplierIdField',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  SupplierCreateForm = new Ext.FormPanel({
        labelAlign: 'top',
        bodyStyle:'padding:5px',
        width: 600,   
		height:650,
		items: [{
            layout:'column',
            border:false,
            items:[{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [NameField2, WebSiteField2,EmailField2,AddressField2]
            },{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [TelephoneField2,MobileField2,FaxField2]
            }]
        }],
    buttons: [{
      text: 'Save and Close',
      handler: createTheSupplier
    },{
      text: 'Cancel',
      handler: function(){
        // because of the global vars, we can only instantiate one window... so let's just hide it.
        SupplierCreateWindow.hide();
      }
    }]
    });
  SupplierCreateWindow= new Ext.Window({
      id: 'SupplierCreateWindow',
      title: 'Creating a New Supplier',
      closable:false,
      width: 610,
      height: 320,
	  modal:true,
      plain:true,
      layout: 'fit',
      items: SupplierCreateForm
    });
};
  
function createEditSuppForm(){

  NameField = new Ext.form.TextField({
    id: 'NameField',
    fieldLabel: 'Name',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  AddressField = new Ext.form.TextArea({
    id: 'AddressField',
    fieldLabel: 'Address',
    allowBlank: false,
    anchor : '95%',    
    maskRe: /([a-zA-Z0-9\s]+)$/  
      });

  TelephoneField = new Ext.form.TextField({
    id: 'TelephoneField',
    fieldLabel: 'Telephone',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  MobileField = new Ext.form.TextField({
    id: 'MobileField',
    fieldLabel: 'Mobile',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  FaxField = new Ext.form.TextField({
    id: 'FaxField',
    fieldLabel: 'Fax',
    maxLength: 20,
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
      });

  WebSiteField = new Ext.form.TextField({
    id: 'WebSiteField',
    fieldLabel: 'WebSite',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });

  EmailField = new Ext.form.TextField({
    id: 'EmailField',
    fieldLabel: 'Email',
    allowBlank: false,
    anchor : '95%'
    //maskRe: /([a-zA-Z0-9\s]+)$/
      });


  SupplierEditForm = new Ext.FormPanel({
        labelAlign: 'top',
		id:'EditForm',
        bodyStyle:'padding:5px',
        width: 600,   
		height:320,
		items: [{
            layout:'column',
            border:false,
            items:[{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [NameField, WebSiteField,EmailField,AddressField]
            },{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [TelephoneField,MobileField,FaxField]
            }]
        }],
    buttons: [{
      text: 'Save and Close',
      handler: updateTheSupplier
    },{
      text: 'Cancel',
      handler: function(){
        // because of the global vars, we can only instantiate one window... so let's just hide it.
        SupplierEditWindow.hide();
      }
    }]
    });
  
  SupplierEditWindow= new Ext.Window({
      id: 'SupplierEditWindow',
      title: 'Edit a Supplier',
      closable:false,
	  modal:true,
      width: 610,
      height: 320,
      plain:true,
      layout: 'fit',
      items: SupplierEditForm
    });
  
};