// JavaScript Document
Ext.ns("Ext.ux.renderer");

Ext.ux.renderer.Progress = function(v, p, record, w){
    var text_post = v + '%';
    var style ='';
    var colored = true;
    if (colored == true)
    {
        if (v <= 100 && v >66) style='-green';
        if (v < 67  && v >33) style='-orange';
        if (v < 34 ) style='-red';
    }
    return String.format('<div class="x-progress-wrap"><div class="x-progress-inner"><div class="x-progress-bar{0}" style="width:{1}%;"><div class="x-progress-text x-progress-text-back">{2}</div><div class="x-progress-text x-progress-text-front">{2}</div></div></div></div>', style, v, text_post);
};
  TasksDataStore = new Ext.data.Store({
      id: 'TasksDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTTASKS"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'Id', type: 'int', mapping: 'Id'},
        {name: 'Task', type: 'string', mapping: 'Task'},
        {name: 'Notes', type: 'string', mapping: 'Notes'},
		{name: 'CreationDate', type: 'date', dateFormat: 'Y-m-d', mapping: 'CreationDate'},
        {name: 'TargetDate', type: 'date', dateFormat: 'Y-m-d', mapping: 'TargetDate'},
		{name: 'FinishDate', type: 'date', dateFormat: 'Y-m-d', mapping: 'FinishDate'},
		{name: 'StartDate', type: 'date', dateFormat: 'Y-m-d', mapping: 'StartDate'},
		{name: 'Status', type: 'int', mapping: 'Status'},
		{name: 'Progress', type: 'int', mapping: 'Progress'},
		{name: 'AssignedTo', type: 'int', mapping: 'AssignedTo'}
      ]),
      sortInfo:{field: 'Id', direction: "ASC"}
    });
  StatusDataStore = new Ext.data.Store({
      id: 'StatusDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTSTATUS"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'Id', type: 'int', mapping: 'Id'},
        {name: 'Name', type: 'string', mapping: 'Name'}
      ]),
      sortInfo:{field: 'Id', direction: "ASC"}
    });
  
  StaffDataStore = new Ext.data.Store({
      id: 'StaffDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTSTAFF"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'Id', type: 'int', mapping: 'Id'},
        {name: 'UserName', type: 'string', mapping: 'UserName'}
      ]),
      sortInfo:{field: 'Id', direction: "ASC"}
    });	

function saveTask(oGrid_event){
   Ext.MessageBox.wait('Updating!', 'Please Wait ...');
   Ext.Ajax.request({   
      waitMsg: 'Please wait...',
      url: 'database.php',
      params: {
         task: "UPDATETASK",
         id: oGrid_event.record.data.Id,
         taskname: oGrid_event.record.data.Task,
         finish: (oGrid_event.record.data.FinishDate) ? oGrid_event.record.data.FinishDate.dateFormat('Y-m-d'):0,
         create: (oGrid_event.record.data.CreationDate) ? oGrid_event.record.data.CreationDate.dateFormat('Y-m-d'):0,
         start: (oGrid_event.record.data.StartDate) ? oGrid_event.record.data.StartDate.dateFormat('Y-m-d'):0,
         target: (oGrid_event.record.data.TargetDate) ? oGrid_event.record.data.TargetDate.dateFormat('Y-m-d'):0,
         status: oGrid_event.record.data.Status,
		 assigned: (oGrid_event.record.data.AssignedTo) ? oGrid_event.record.data.AssignedTo:0,
		 progress: oGrid_event.record.data.Progress
      }, 
      success: function(response){              
         var result=eval(response.responseText);
         switch(result){
         case 1:
            Ext.MessageBox.hide();
			ClientsDataStore.commitChanges();
            ClientsDataStore.reload();
            break;          
         default:
            Ext.MessageBox.hide();
			Ext.MessageBox.alert(response.responseText);
            break;
         }
      },
      failure: function(response){
         Ext.MessageBox.hide();
		 var result=response.responseText;
         Ext.MessageBox.alert('error','could not connect to the database. retry later');    
      }                      
   });   
}
function createTask(){
   Ext.MessageBox.wait('Updating!', 'Please Wait ...');
   Ext.Ajax.request({   
      waitMsg: 'Please wait...',
      url: 'database.php',
      params: {
         task: "ADDTASK",
         //id: oGrid_event.record.data.Id,
         taskname: TaskField.getValue(),
         finish: (FinishField.getValue()) ? FinishField.getValue().dateFormat('Y-m-d'):0,
         create: (CreatedField.getValue()) ? CreatedField.getValue().dateFormat('Y-m-d'):0,
         start: (StartField.getValue()) ? StartField.getValue().dateFormat('Y-m-d'):0,
         target: (TargetField.getValue()) ? TargetField.getValue().dateFormat('Y-m-d'):0,
         status: StatusField.getValue(),
		 assigned: (AssignedToField.getValue()) ? AssignedToField.getValue():0,
		 progress: ProgressField.getValue()
      }, 
      success: function(response){              
         var result=eval(response.responseText);
         switch(result){
         case 1:
            Ext.MessageBox.hide();
			TasksDataStore.commitChanges();
            TasksDataStore.reload();
			TaskCreateWindow.close();
            break;          
         default:
            Ext.MessageBox.hide();
			Ext.MessageBox.alert('Could not add Task');
            break;
         }
      },
      failure: function(response){
         Ext.MessageBox.hide();
		 var result=response.responseText;
         Ext.MessageBox.alert('error','could not connect to the database. retry later');    
      }                      
   });   
}

  function confirmDeleteNotes(){
    if(TasksNotesEditorGrid.selModel.getCount() == 1) // only one Client is selected here
    {
      Ext.MessageBox.confirm('Confirmation','You are about to delete a Note. Continue?', deleteNotes);
    } else if(TasksNotesEditorGrid.selModel.getCount() > 1){
      Ext.MessageBox.confirm('Confirmation','Delete those Notes?', deleteNotes);
    } else {
      Ext.MessageBox.alert('Error','Please select Note(s) to delete');
    }
  }  
   // This was added in Tutorial 6
  function deleteNotes(btn){
    if(btn=='yes'){
         var selections = TasksNotesEditorGrid.selModel.getSelections();
		 var selections2 = TasksListingEditorGrid.selModel.getSelections();
         //console.info('first:'+selections[0].data['IDClient']);
		 var prez = [];
         for(i = 0; i< TasksNotesEditorGrid.selModel.getCount(); i++){
          prez.push(selections[i].data['Id']);
		  
		  //console.info(selections[0].data['IDClient']);
         }
         var encoded_array = Ext.encode(prez);
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url: 'database.php', 
            params: { 
               task: "DELETENOTE", 
               ids:  encoded_array
              }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1:  // Success : simply reload
                NotesDataStore.load({params: {id:selections2[0].json.Id}});
                break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }

  function confirmDeleteTasks(){
    if(TasksListingEditorGrid.selModel.getCount() == 1) // only one Client is selected here
    {
      Ext.MessageBox.confirm('Confirmation','You are about to delete a Task. Continue?', deleteTasks);
    } else if(TasksListingEditorGrid.selModel.getCount() > 1){
      Ext.MessageBox.confirm('Confirmation','Delete those Tasks?', deleteTasks);
    } else {
      Ext.MessageBox.alert('Error','Please select Task(s) to delete');
    }
  }  
   // This was added in Tutorial 6
  function deleteTasks(btn){
    if(btn=='yes'){
         var selections = TasksListingEditorGrid.selModel.getSelections();
         //console.info('first:'+selections[0].data['IDClient']);
		 var prez = [];
         for(i = 0; i< TasksListingEditorGrid.selModel.getCount(); i++){
          prez.push(selections[i].data['Id']);
		  
		  //console.info(selections[0].data['IDClient']);
         }
         var encoded_array = Ext.encode(prez);
         Ext.Ajax.request({  
            waitMsg: 'Please Wait',
            url: 'database.php', 
            params: { 
               task: "DELETETASK", 
               ids:  encoded_array
              }, 
            success: function(response){
              var result=eval(response.responseText);
              switch(result){
              case 1:  // Success : simply reload
                TasksDataStore.reload();
                break;
              default:
                Ext.MessageBox.alert('Warning','Could not delete the entire selection.');
                break;
              }
            },
            failure: function(response){
              var result=response.responseText;
              Ext.MessageBox.alert('error','could not connect to the database. retry later');      
              }
         });
      }  
  }
  function saveNote(oGrid_event){
	var selections = TasksNotesEditorGrid.selModel.getSelections();
	var selections2 = TasksListingEditorGrid.selModel.getSelections();
	Ext.MessageBox.wait('Updating!', 'Please Wait ...');
	Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "UPDATENOTE",
          id: 				  oGrid_event.record.data.Id,
		  note:      	  		oGrid_event.record.data.Note,
		  create:      	  	  (oGrid_event.record.data.CreationDate) ? oGrid_event.record.data.CreationDate.dateFormat('Y-m-d'):0,
		  userid:      	  	  (oGrid_event.record.data.UserId) ? oGrid_event.record.data.UserId:0,
          taskid:       	  	  selections2[0].json.Id
        }, 
        success: function(response){              
          Ext.MessageBox.hide();
		  var result=eval(response.responseText);
          //console.log(result);
		  switch(result){
          case 1:
		  case 0:
			Ext.MessageBox.alert('Update OK','The Task Note was updated successfully.');
			NotesDataStore.load({params: {id:selections2[0].json.Id}});
			//AddMaterialWindow.close();
            break;
          default:
            Ext.MessageBox.alert('Could not update the Task Note');
            break;
          }        
        },
        failure: function(response){
		  Ext.MessageBox.hide();
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
  }

function createTaskDs(){
};
function createTaskGrid(){
  TasksColumnModel = new Ext.grid.ColumnModel(
    [{
        header: '#',
        readOnly: true,
        dataIndex: 'Id',
        width: 10,        
        renderer: function(value, cell){ 
         //cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Task',
        dataIndex: 'Task',
		width: 60,
        editor: new Ext.form.TextField({
            allowBlank: false,
            maxLength: 20,
            maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell) {
var str = "<p style='white-space:normal'>" + value + "</p>";
return str;
},
		css: 'white-space:normal;'

      },{
        header: 'Created',
        dataIndex: 'CreationDate',
		format : 'Y-m-d',
        width: 30,
        editor: new Ext.form.DateField({
    		format : 'Y-m-d',
    		allowBlank: false
          }),
        renderer: Ext.util.Format.dateRenderer("d/m/Y")
      },{
        header: 'Target',
        dataIndex: 'TargetDate',
		format : 'Y-m-d',
        width: 30,
        editor: new Ext.form.DateField({
    		format : 'Y-m-d',
    		allowBlank: false
          }),
        renderer: Ext.util.Format.dateRenderer("d/m/Y")
      },{
        header: 'Start',
        dataIndex: 'StartDate',
		format : 'Y-m-d',
        width: 30,
        editor: new Ext.form.DateField({
    		format : 'Y-m-d',
    		allowBlank: false
          }),
        renderer: Ext.util.Format.dateRenderer("d/m/Y")
      },{
        header: 'Finished',
        dataIndex: 'FinishDate',
		format : 'Y-m-d',
        width: 30,
        editor: new Ext.form.DateField({
    		format : 'Y-m-d',
    		allowBlank: false
          }),
        renderer: Ext.util.Format.dateRenderer("d/m/Y")
      },{
        header: 'Status',
        dataIndex: 'Status',
        width: 80,
        editor: new Ext.form.ComboBox({
          store:StatusDataStore,
     	  mode: 'local',
     	  displayField: 'Name',
     	  allowBlank: false,
          valueField: 'Id',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(data,value, cell){ 
			//cell.css = "coolcell";
			record = StatusDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.Name;
            } else {
                                    //return data;
                return data;
            }        
		}
      },{
        header: 'Assigned To',
        dataIndex: 'AssignedTo',
        width: 80,
        editor: new Ext.form.ComboBox({
          store:StaffDataStore,
     	  mode: 'local',
     	  displayField: 'UserName',
     	  allowBlank: false,
          valueField: 'Id',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(data,value, cell){ 
			//cell.css = "coolcell";
			record = StaffDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.UserName;
            } else {
                                    //return data;
                return 'Not Assigned';
            }        
		}
      },{
		  header: "% Completed", 
		  width: 100, 
		  sortable: true, 
		  renderer: Ext.ux.renderer.Progress, 
		  dataIndex: 'Progress',
		  editor:new Ext.form.NumberField({
    		allowNegative: false,
    		allowBlank: false
    	})}
       
      ]
    );
    TasksColumnModel.defaultSortable= true;
  TasksListingEditorGrid =  new Ext.grid.EditorGridPanel({
      id: 'TasksListingEditorGrid',
      store: TasksDataStore,
      cm: TasksColumnModel,
      enableColLock:false,
      clicksToEdit:2,
      viewConfig: {
        forceFit: true
    },
	  selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
      bbar: new Ext.PagingToolbar({
                pageSize: 15,
                store: TasksDataStore,
                displayInfo: true
            }),
      tbar: [
          {
            text: 'Notes',
            tooltip: 'Task\s Notes',
            iconCls:'material',                      // reference to our css
            handler: displayNotesWindow
          },'-',{
            text: 'Add a Task',
            tooltip: 'Add a new client',
            iconCls:'add',                      // reference to our css
            handler: createAddTaskWindow
          }, '-', { 
            text: 'Delete selection',
            tooltip: 'Please select a Task',
            handler: confirmDeleteTasks,   // Confirm before deleting
            iconCls:'remove'
          }, '-', { // Added in Tutorial 8
            text: 'Search',
            tooltip: 'Advanced Search',
            //handler: startAdvancedSearch,   
            iconCls:'search'
          }, '-', new Ext.app.SearchField({
                    store: ClientsDataStore,
            params: {start: 0, limit: 15},
                    width: 120
        }),'-', {
            text: 'Print',
        tooltip: 'Print me!',
            handler: printListing, 
            iconCls:'print'
          }
      ]
    });
  TasksListingEditorGrid.addListener('rowcontextmenu', onClientListingEditorGridContextMenu);
  TasksListingEditorGrid.on('afteredit',saveTask);
/*  TasksListingEditorGrid.on('rowdblclick', function(grid, rowIndex) {
         var record = grid.store.getAt(rowIndex);
         if (record) {
                //console.info('You selected ' + record.get('AufgabenNr'));
				editFormWindow(record);
         }
       

    });	
 */	
};
function createAddTaskWindow(act){
  TaskField = new Ext.form.TextField({
    id: 'TaskField',
    fieldLabel: 'Task',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
  });
  NotesField = new Ext.form.TextField({
    id: 'NotesField',
    fieldLabel: 'Notes',
    allowBlank: false,
    anchor : '95%',
    maskRe: /([a-zA-Z0-9\s]+)$/
  });
  
  CreatedField = new Ext.form.DateField({
    id:'CreatedField',
    fieldLabel: 'Date Created',
    allowBlank: false,
    format : 'd/m/Y',
    anchor:'95%'
    });
  FinishField = new Ext.form.DateField({
    id:'FinishField',
    fieldLabel: 'Date Finished',
    allowBlank: false,
    format : 'd/m/Y',
    anchor:'95%'
    });
  StartField = new Ext.form.DateField({
    id:'StartField',
    fieldLabel: 'Date Started',
    allowBlank: false,
    format : 'd/m/Y',
    anchor:'95%'
    });
  TargetField = new Ext.form.DateField({
    id:'TargetField',
    fieldLabel: 'Target Date',
    allowBlank: false,
    format : 'd/m/Y',
    anchor:'95%'
    });
  StatusField = new Ext.form.ComboBox({
     id:'StatusField',
     fieldLabel: 'Status',
     store:StatusDataStore,
     mode: 'local',
     displayField: 'Name',
     allowBlank: false,
     valueField: 'Id',
     anchor:'95%',
     triggerAction: 'all'
      });
  AssignedToField = new Ext.form.ComboBox({
     id:'AssignedToField',
     fieldLabel: 'Assigned To',
     store:StaffDataStore,
     mode: 'local',
     displayField: 'UserName',
     allowBlank: false,
     valueField: 'Id',
     anchor:'95%',
     triggerAction: 'all'
      });
  ProgressField = new Ext.form.NumberField({
    id:'ProgressField',
    fieldLabel: 'Progress',
    allowNegative: false,
    allowBlank: false,
    anchor:'95%'
    });
  TaskCreateForm = new Ext.FormPanel({
        labelAlign: 'top',
        bodyStyle:'padding:5px',
        width: 600,   
		height:450,
		items: [{
            layout:'column',
            border:false,
            items:[{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [TaskField,NotesField, ProgressField,StatusField,AssignedToField]
            },{
                columnWidth:0.5,
                layout: 'form',
                border:false,
                items: [FinishField,StartField,TargetField,CreatedField]
            }]
        }],
    buttons: [{
      text: 'Save and Close',
      handler: createTask
    },{
      text: 'Cancel',
      handler: function(){
        // because of the global vars, we can only instantiate one window... so let's just hide it.
        TaskCreateWindow.close();
      }
    }]
    });

  TaskCreateWindow= new Ext.Window({
      id: 'TaskCreateWindow',
      title: 'Creating a New Task',
      closable:false,
	  modal:true,
      width: 610,
      height: 410,
      plain:true,
      layout: 'fit',
      items: TaskCreateForm
    });
  TaskCreateWindow.show();
};
  function displayNotesWindow(rec){
	//createMatWindo();
	
	if(TasksListingEditorGrid.selModel.getCount() > 0) {
		//ProductsDataStore.load();
		//SuppliersDataStore.load();
		var selections = TasksListingEditorGrid.selModel.getSelections();
		NotesDataStore.load({params: {id:selections[0].json.Id}});
		if(!NotesWindow.isVisible()){
       		//resetClientForm();
       		NotesWindow.show();
	    } else {
       		NotesWindow.toFront();
     	}
	} else {
		Ext.MessageBox.alert('Error','Please select a Task');
	}
		
	
  }

  function addNewNote(){
	var selections = TasksListingEditorGrid.selModel.getSelections();
	var today = new Date();
	var mon=today.getMonth()+1;
	var dataStr = today.getFullYear()+'-'+mon+'-'+today.getDate();
	Ext.MessageBox.wait('Updating!', 'Please Wait ...');
	Ext.Ajax.request({   
        waitMsg: 'Please wait...',
        url: 'database.php',
        params: {
          task: "ADDNOTE",
          id: 				  selections[0].json.Id,
		  note:      	  		"New Note...",
          date: 				dataStr
        }, 
        success: function(response){              
          Ext.MessageBox.hide();
		  var result=eval(response.responseText);
          //console.log(result);
		  switch(result){
          case 1:
		  case 0:
			Ext.MessageBox.alert('Update OK','The Note was added successfully.');
			NotesDataStore.load({params: {id:selections[0].json.Id}});
			//AddMaterialWindow.close();
            break;
          default:
            Ext.MessageBox.alert('Could not add the note');
            break;
          }        
        },
        failure: function(response){
		  Ext.MessageBox.hide();
          Ext.MessageBox.alert('error','could not connect to the database. retry later');         
        }                      
      });
  }

  NotesDataStore = new Ext.data.Store({
      id: 'NotesDataStore',
      proxy: new Ext.data.HttpProxy({
                url: 'database.php', 
                method: 'POST'
            }),
            baseParams:{task: "LISTNOTES",
						id: "1"}, // this parameter is passed for any HTTP request
      reader: new Ext.data.JsonReader({
        root: 'results',
        totalProperty: 'total',
        id: 'Id'
      },[ 
        {name: 'Id', type: 'int', mapping: 'Id'},
		{name: 'UserId', type: 'int', mapping: 'UserId'},
        {name: 'TaskId', type: 'string', mapping: 'TaskId'},
        {name: 'Note', type: 'string', mapping: 'Note'},
		{name: 'CreationDate', type: 'date', dateFormat: 'Y-m-d', mapping: 'CreationDate'}
      ]),
      sortInfo:{field: 'Id', direction: "ASC"}
    });

  TasksNotesEditorGrid =  new Ext.grid.EditorGridPanel({
      id: 'TasksNotesEditorGrid',
      store: NotesDataStore,
      columns: [{
        header: '#',
        readOnly: true,
        dataIndex: 'Id',
        width: 10,        
        renderer: function(value, cell){ 
         //cell.css = "readonlycell";
         return value;
        },
        hidden: false
      },{
        header: 'Note',
        dataIndex: 'Note',
        width: 300,
        editor: new Ext.form.HtmlEditor({
            allowBlank: false,
            //maxLength: 20,
            maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(value, cell) {
var str = "<p style='white-space:normal'>" + value + "</p>";
return str;
},
		css: 'white-space:normal;'
      },{
        header: 'Date',
        dataIndex: 'CreationDate',
		format : 'Y-m-d',
        width: 50,
        editor: new Ext.form.DateField({
    		format : 'Y-m-d',
    		allowBlank: false
          }),
        renderer: Ext.util.Format.dateRenderer("d/m/Y")
      },{
        header: 'By',
        dataIndex: 'UserId',
        width: 80,
        editor: new Ext.form.ComboBox({
          store:StaffDataStore,
     	  mode: 'local',
     	  displayField: 'UserName',
     	  allowBlank: false,
          valueField: 'Id',
		  typeAhead: false,
		  triggerAction: 'all',
		  lazyRender: true,
		  allowBlank: false,
          maxLength: 20,
          maskRe: /([a-zA-Z0-9\s]+)$/
          }),
        renderer: function(data,value, cell){ 
			//cell.css = "coolcell";
			record = StaffDataStore.getById(data);//same as accessing this.data.key(id)
            if(record) {
            	return record.data.UserName;
            } else {
                                    //return data;
                return 'Not Assigned';
            }        
		}
      }
	  
	  
	  
	  ],
      enableColLock:false,
      clicksToEdit:2,
      viewConfig: {
        forceFit: true
    },
	  selModel: new Ext.grid.RowSelectionModel({singleSelect:false}),
      bbar: new Ext.PagingToolbar({
                pageSize: 15,
                store: NotesDataStore,
                displayInfo: true
            }),
      tbar: [
          {
            text: 'Add a Note',
            tooltip: 'Add a new Note',
            iconCls:'add',                      // reference to our css
            handler: addNewNote
          }, '-', { 
            text: 'Delete selection',
            tooltip: 'Please select a Note',
            handler: confirmDeleteNotes,   // Confirm before deleting
            iconCls:'remove'
          }, '-', { // Added in Tutorial 8
            text: 'Search',
            tooltip: 'Advanced Search',
            //handler: startAdvancedSearch,   
            iconCls:'search'
          }, '-', new Ext.app.SearchField({
                    store: ClientsDataStore,
            params: {start: 0, limit: 15},
                    width: 120
        }),'-', {
            text: 'Print',
        tooltip: 'Print me!',
            handler: printListing, 
            iconCls:'print'
          }, '-', { // Added in Tutorial 8
            text: 'Close',
            tooltip: 'Advanced Search',
            handler: closeNotes,   
            iconCls:'search'
          }
      ]
    });
  TasksNotesEditorGrid.on('afteredit',saveNote);
  NotesWindow= new Ext.Window({
      id: 'NotesWindow',
      title: 'Task\'s Notes',
      closable:false,
	  modal:true,
      width: 610,
      height: 410,
      plain:true,
      layout: 'fit',
      items: TasksNotesEditorGrid
    });
  function closeNotes(){
  	NotesWindow.hide();
  }
